


COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


NAME
       collectd.conf - Configuration for the system statistics collection
       daemon collectd

SYNOPSIS
         BaseDir "/path/to/data/"
         PIDFile "/path/to/pidfile/collectd.pid"
         Server  "123.123.123.123" 12345

         LoadPlugin cpu
         LoadPlugin load
         LoadPlugin ping

         <Plugin ping>
           Host "example.org"
           Host "provider.net"
         </Plugin>

DESCRIPTION
       This config file controls how the system statistics collection daemon
       collectd behaves. The most significant option is LoadPlugin, which
       controls which plugins to load. These plugins ultimately define
       collectd's behavior.

       The syntax of this config file is similar to the config file of the
       famous Apache Webserver. Each line contains either a key-value-pair or
       a section-start or -end. Empty lines and everything after the hash-
       symbol `#' is ignored. Values are either string, enclosed in double-
       quotes, (floating-point-)numbers or a boolean expression, i. e. either
       true or false. String containing of only alphanumeric characters and
       underscores do not need to be quoted. Lines may be wrapped by using `\'
       as the last character before the newline. This allows long lines to be
       split into multiple lines.  Quoted strings may be wrapped as well.
       However, those are treated special in that whitespace at the beginning
       of the following lines will be ignored, which allows for nicely
       indenting the wrapped lines.

       The configuration is read and processed in order, i. e. from top to
       bottom. So the plugins are loaded in the order listed in this config
       file. It is a good idea to load any logging plugins first in order to
       catch messages from plugins during configuration. Also, the
       "LoadPlugin" option must occur before the "<Plugin ...>" block.

GLOBAL OPTIONS
       BaseDir Directory
           Sets the base directory. This is the directory beneath all RRD-
           files are created. Possibly more subdirectories are created. This
           is also the working directory for the daemon.

       LoadPlugin Plugin
           Loads the plugin Plugin. There must be at least one such line or
           collectd will be mostly useless.

           Starting with collectd 4.9, this may also be a block in which



4.10.2                      2010-11-27                          1





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


           further options affecting the behavior of LoadPlugin may be
           specified. The following options are allowed inside a LoadPlugin
           block:

             <LoadPlugin perl>
               Globals true
             </LoadPlugin>

           Globals true|false
               If enabled, collectd will export all global symbols of the
               plugin (and of all libraries loaded as dependencies of the
               plugin) and, thus, makes those symbols available for resolving
               unresolved symbols in subsequently loaded plugins if that is
               supported by your system. By default, this is disabled.

               This is useful (or possibly even required), e. g., when loading
               a plugin that embeds some scripting language into the daemon
               (e. g. the "perl" or "python" plugins). Scripting languages
               usually provide means to load extensions written in C. Those
               extensions require symbols provided by the interpreter, which
               is loaded as a dependency of the respective collectd plugin.
               See the documentation of those plugins (e. g., collectd-perl(5)
               or collectd-python(5)) for details.

       Include Path
           If Path points to a file, includes that file. If Path points to a
           directory, recursively includes all files within that directory and
           its subdirectories. If the "wordexp" function is available on your
           system, shell-like wildcards are expanded before files are
           included. This means you can use statements like the following:

             Include "/etc/collectd.d/*.conf"

           If more than one files are included by a single Include option, the
           files will be included in lexicographical order (as defined by the
           "strcmp" function). Thus, you can e. g. use numbered prefixes to
           specify the order in which the files are loaded.

           To prevent loops and shooting yourself in the foot in interesting
           ways the nesting is limited to a depth of 8 levels, which should be
           sufficient for most uses. Since symlinks are followed it is still
           possible to crash the daemon by looping symlinks. In our opinion
           significant stupidity should result in an appropriate amount of
           pain.

           It is no problem to have a block like "<Plugin foo>" in more than
           one file, but you cannot include files from within blocks.

       PIDFile File
           Sets where to write the PID file to. This file is overwritten when
           it exists and deleted when the program is stopped. Some init-
           scripts might override this setting using the -P command-line
           option.




4.10.2                      2010-11-27                          2





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       PluginDir Directory
           Path to the plugins (shared objects) of collectd.

       TypesDB File [File ...]
           Set one or more files that contain the data-set descriptions. See
           types.db(5) for a description of the format of this file.

       Interval Seconds
           Configures the interval in which to query the read plugins.
           Obviously smaller values lead to a higher system load produced by
           collectd, while higher values lead to more coarse statistics.

           Warning: You should set this once and then never touch it again. If
           you do, you will have to delete all your RRD files or know some
           serious RRDtool magic! (Assuming you're using the RRDtool or
           RRDCacheD plugin.)

       Timeout Iterations
           Consider a value list "missing" when no update has been read or
           received for Iterations iterations. By default, collectd considers
           a value list missing when no update has been received for twice the
           update interval. Since this setting uses iterations, the maximum
           allowed time without update depends on the Interval information
           contained in each value list. This is used in the Threshold
           configuration to dispatch notifications about missing values, see
           "THRESHOLD CONFIGURATION" below.

       ReadThreads Num
           Number of threads to start for reading plugins. The default value
           is 5, but you may want to increase this if you have more than five
           plugins that take a long time to read. Mostly those are plugin that
           do network-IO. Setting this to a value higher than the number of
           plugins you've loaded is totally useless.

       Hostname Name
           Sets the hostname that identifies a host. If you omit this setting,
           the hostname will be determined using the gethostname(2) system
           call.

       FQDNLookup true|false
           If Hostname is determined automatically this setting controls
           whether or not the daemon should try to figure out the "fully
           qualified domain name", FQDN.  This is done using a lookup of the
           name returned by "gethostname".

           Using this feature (i. e. setting this option to true) is
           recommended.  However, to preserve backwards compatibility the
           default is set to false.  The sample config file that is installed
           with "make install" includes a line which sets this option, though,
           so that default installations will have this setting enabled.

       PreCacheChain ChainName
       PostCacheChain ChainName
           Configure the name of the "pre-cache chain" and the "post-cache



4.10.2                      2010-11-27                          3





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


           chain". Please see "FILTER CONFIGURATION" below on information on
           chains and how these setting change the daemon's behavior.

PLUGIN OPTIONS
       Some plugins may register own options. These options must be enclosed
       in a "Plugin"-Section. Which options exist depends on the plugin used.
       Some plugins require external configuration, too. The "apache plugin",
       for example, required "mod_status" to be configured in the webserver
       you're going to collect data from. These plugins are listed below as
       well, even if they don't require any configuration within collectd's
       configfile.

       A list of all plugins and a short summary for each plugin can be found
       in the README file shipped with the sourcecode and hopefully binary
       packets as well.

   Plugin "apache"
       To configure the "apache"-plugin you first need to configure the Apache
       webserver correctly. The Apache-plugin "mod_status" needs to be loaded
       and working and the "ExtendedStatus" directive needs to be enabled. You
       can use the following snipped to base your Apache config upon:

         ExtendedStatus on
         <IfModule mod_status.c>
           <Location /mod_status>
             SetHandler server-status
           </Location>
         </IfModule>

       Since its "mod_status" module is very similar to Apache's, lighttpd is
       also supported. It introduces a new field, called "BusyServers", to
       count the number of currently connected clients. This field is also
       supported.

       The following options are accepted by the "apache"-plugin:

       URL http://host/mod_status?auto
           Sets the URL of the "mod_status" output. This needs to be the
           output generated by "ExtendedStatus on" and it needs to be the
           machine readable output generated by appending the "?auto"
           argument.

       User Username
           Optional user name needed for authentication.

       Password Password
           Optional password needed for authentication.

       VerifyPeer true|false
           Enable or disable peer SSL certificate verification. See
           <http://curl.haxx.se/docs/sslcerts.html> for details. Enabled by
           default.





4.10.2                      2010-11-27                          4





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       VerifyHost true|false
           Enable or disable peer host name verification. If enabled, the
           plugin checks if the "Common Name" or a "Subject Alternate Name"
           field of the SSL certificate matches the host name provided by the
           URL option. If this identity check fails, the connection is
           aborted. Obviously, only works when connecting to a SSL enabled
           server. Enabled by default.

       CACert File
           File that holds one or more SSL certificates. If you want to use
           HTTPS you will possibly need this option. What CA certificates come
           bundled with "libcurl" and are checked by default depends on the
           distribution you use.

   Plugin "apcups"
       Host Hostname
           Hostname of the host running apcupsd. Defaults to localhost. Please
           note that IPv6 support has been disabled unless someone can confirm
           or decline that apcupsd can handle it.

       Port Port
           TCP-Port to connect to. Defaults to 3551.

   Plugin "ascent"
       This plugin collects information about an Ascent server, a free server
       for the "World of Warcraft" game. This plugin gathers the information
       by fetching the XML status page using "libcurl" and parses it using
       "libxml2".

       The configuration options are the same as for the "apache" plugin
       above:

       URL http://localhost/ascent/status/
           Sets the URL of the XML status output.

       User Username
           Optional user name needed for authentication.

       Password Password
           Optional password needed for authentication.

       VerifyPeer true|false
           Enable or disable peer SSL certificate verification. See
           <http://curl.haxx.se/docs/sslcerts.html> for details. Enabled by
           default.

       VerifyHost true|false
           Enable or disable peer host name verification. If enabled, the
           plugin checks if the "Common Name" or a "Subject Alternate Name"
           field of the SSL certificate matches the host name provided by the
           URL option. If this identity check fails, the connection is
           aborted. Obviously, only works when connecting to a SSL enabled
           server. Enabled by default.




4.10.2                      2010-11-27                          5





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       CACert File
           File that holds one or more SSL certificates. If you want to use
           HTTPS you will possibly need this option. What CA certificates come
           bundled with "libcurl" and are checked by default depends on the
           distribution you use.

   Plugin "bind"
       Starting with BIND 9.5.0, the most widely used DNS server software
       provides extensive statistics about queries, responses and lots of
       other information.  The bind plugin retrieves this information that's
       encoded in XML and provided via HTTP and submits the values to
       collectd.

       To use this plugin, you first need to tell BIND to make this
       information available. This is done with the "statistics-channels"
       configuration option:

        statistics-channels {
          inet localhost port 8053;
        };

       The configuration follows the grouping that can be seen when looking at
       the data with an XSLT compatible viewer, such as a modern web browser.
       It's probably a good idea to make yourself familiar with the provided
       values, so you can understand what the collected statistics actually
       mean.

       Synopsis:

        <Plugin "bind">
          URL "http://localhost:8053/"
          OpCodes         true
          QTypes          true

          ServerStats     true
          ZoneMaintStats  true
          ResolverStats   false
          MemoryStats     true

          <View "_default">
            QTypes        true
            ResolverStats true
            CacheRRSets   true

            Zone "127.in-addr.arpa/IN"
          </View>
        </Plugin>

       The bind plugin accepts the following configuration options:

       URL URL
           URL from which to retrieve the XML data. If not specified,
           "http://localhost:8053/" will be used.




4.10.2                      2010-11-27                          6





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       OpCodes true|false
           When enabled, statistics about the "OpCodes", for example the
           number of "QUERY" packets, are collected.

           Default: Enabled.

       QTypes true|false
           When enabled, the number of incoming queries by query types (for
           example "A", "MX", "AAAA") is collected.

           Default: Enabled.

       ServerStats true|false
           Collect global server statistics, such as requests received over
           IPv4 and IPv6, successful queries, and failed updates.

           Default: Enabled.

       ZoneMaintStats true|false
           Collect zone maintenance statistics, mostly information about
           notifications (zone updates) and zone transfers.

           Default: Enabled.

       ResolverStats true|false
           Collect resolver statistics, i. e. statistics about outgoing
           requests (e. g. queries over IPv4, lame servers). Since the global
           resolver counters apparently were removed in BIND 9.5.1 and 9.6.0,
           this is disabled by default. Use the ResolverStats option within a
           View "_default" block instead for the same functionality.

           Default: Disabled.

       MemoryStats
           Collect global memory statistics.

           Default: Enabled.

       View Name
           Collect statistics about a specific "view". BIND can behave
           different, mostly depending on the source IP-address of the
           request. These different configurations are called "views". If you
           don't use this feature, you most likely are only interested in the
           "_default" view.

           Within a <View name> block, you can specify which information you
           want to collect about a view. If no View block is configured, no
           detailed view statistics will be collected.

           QTypes true|false
               If enabled, the number of outgoing queries by query type (e. g.
               "A", "MX") is collected.

               Default: Enabled.



4.10.2                      2010-11-27                          7





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


           ResolverStats true|false
               Collect resolver statistics, i. e. statistics about outgoing
               requests (e. g. queries over IPv4, lame servers).

               Default: Enabled.

           CacheRRSets true|false
               If enabled, the number of entries ("RR sets") in the view's
               cache by query type is collected. Negative entries (queries
               which resulted in an error, for example names that do not
               exist) are reported with a leading exclamation mark, e. g.
               "!A".

               Default: Enabled.

           Zone Name
               When given, collect detailed information about the given zone
               in the view. The information collected if very similar to the
               global ServerStats information (see above).

               You can repeat this option to collect detailed information
               about multiple zones.

               By default no detailed zone information is collected.

   Plugin "cpufreq"
       This plugin doesn't have any options. It reads
       /sys/devices/system/cpu/cpu0/cpufreq/scaling_cur_freq (for the first
       CPU installed) to get the current CPU frequency. If this file does not
       exist make sure cpufreqd (<http://cpufreqd.sourceforge.net/>) or a
       similar tool is installed and an "cpu governor" (that's a kernel
       module) is loaded.

   Plugin "csv"
       DataDir Directory
           Set the directory to store CSV-files under. Per default CSV-files
           are generated beneath the daemon's working directory, i. e. the
           BaseDir.  The special strings stdout and stderr can be used to
           write to the standard output and standard error channels,
           respectively. This, of course, only makes much sense when collectd
           is running in foreground- or non-daemon-mode.

       StoreRates true|false
           If set to true, convert counter values to rates. If set to false
           (the default) counter values are stored as is, i. e. as an
           increasing integer number.

   Plugin "curl"
       The curl plugin uses the libcurl (<http://curl.haxx.se/>) to read web
       pages and the match infrastructure (the same code used by the tail
       plugin) to use regular expressions with the received data.

       The following example will read the current value of AMD stock from
       Google's finance page and dispatch the value to collectd.



4.10.2                      2010-11-27                          8





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


         <Plugin curl>
           <Page "stock_quotes">
             URL "http://finance.google.com/finance?q=NYSE%3AAMD"
             User "foo"
             Password "bar"
             <Match>
               Regex "<span +class=\"pr\"[^>]*> *([0-9]*\\.[0-9]+) *</span>"
               DSType "GaugeAverage"
               # Note: `stock_value' is not a standard type.
               Type "stock_value"
               Instance "AMD"
             </Match>
           </Page>
         </Plugin>

       In the Plugin block, there may be one or more Page blocks, each
       defining a web page and one or more "matches" to be performed on the
       returned data. The string argument to the Page block is used as plugin
       instance.

       The following options are valid within Page blocks:

       URL URL
           URL of the web site to retrieve. Since a regular expression will be
           used to extract information from this data, non-binary data is a
           big plus here ;)

       User Name
           Username to use if authorization is required to read the page.

       Password Password
           Password to use if authorization is required to read the page.

       VerifyPeer true|false
           Enable or disable peer SSL certificate verification. See
           <http://curl.haxx.se/docs/sslcerts.html> for details. Enabled by
           default.

       VerifyHost true|false
           Enable or disable peer host name verification. If enabled, the
           plugin checks if the "Common Name" or a "Subject Alternate Name"
           field of the SSL certificate matches the host name provided by the
           URL option. If this identity check fails, the connection is
           aborted. Obviously, only works when connecting to a SSL enabled
           server. Enabled by default.

       CACert file
           File that holds one or more SSL certificates. If you want to use
           HTTPS you will possibly need this option. What CA certificates come
           bundled with "libcurl" and are checked by default depends on the
           distribution you use.

       MeasureResponseTime true|false
           Measure response time for the request. If this setting is enabled,



4.10.2                      2010-11-27                          9





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


           Match blocks (see below) are optional. Disabled by default.

       <Match>
           One or more Match blocks that define how to match information in
           the data returned by "libcurl". The "curl" plugin uses the same
           infrastructure that's used by the "tail" plugin, so please see the
           documentation of the "tail" plugin below on how matches are
           defined. If the MeasureResponseTime option is set to true, Match
           blocks are optional.

   Plugin "curl_json"
       The curl_json plugin uses libcurl (<http://curl.haxx.se/>) and libyajl
       (<http://www.lloydforge.org/projects/yajl/>) to retrieve JSON data via
       cURL. This can be used to collect values from CouchDB documents (which
       are stored JSON notation), for example.

       The following example will collect several values from the built-in
       `_stats' runtime statistics module of CouchDB
       (<http://wiki.apache.org/couchdb/Runtime_Statistics>).

         <Plugin curl_json>
           <URL "http://localhost:5984/_stats">
             Instance "httpd"
             <Key "httpd/requests/count">
               Type "http_requests"
             </Key>

             <Key "httpd_request_methods/*/count">
               Type "http_request_methods"
             </Key>

             <Key "httpd_status_codes/*/count">
               Type "http_response_codes"
             </Key>
           </URL>
         </Plugin>

       Another CouchDB example: The following example will collect the status
       values from each database:

         <URL "http://localhost:5984/_all_dbs">
           Instance "dbs"
           <Key "*/doc_count">
             Type "gauge"
           </Key>
           <Key "*/doc_del_count">
             Type "counter"
           </Key>
           <Key "*/disk_size">
             Type "bytes"
           </Key>
         </URL>

       In the Plugin block, there may be one or more URL blocks, each defining



4.10.2                      2010-11-27                         10





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       a URL to be fetched via HTTP (using libcurl) and one or more Key
       blocks.  The Key string argument must be in a path format, which is
       used to collect a value from a JSON map object. If a path element of
       Key is the * wildcard, the values for all keys will be collectd.

       The following options are valid within URL blocks:

       Instance Instance
           Sets the plugin instance to Instance.

       User Name
           Username to use if authorization is required to read the page.

       Password Password
           Password to use if authorization is required to read the page.

       VerifyPeer true|false
           Enable or disable peer SSL certificate verification. See
           <http://curl.haxx.se/docs/sslcerts.html> for details. Enabled by
           default.

       VerifyHost true|false
           Enable or disable peer host name verification. If enabled, the
           plugin checks if the "Common Name" or a "Subject Alternate Name"
           field of the SSL certificate matches the host name provided by the
           URL option. If this identity check fails, the connection is
           aborted. Obviously, only works when connecting to a SSL enabled
           server. Enabled by default.

       CACert file
           File that holds one or more SSL certificates. If you want to use
           HTTPS you will possibly need this option. What CA certificates come
           bundled with "libcurl" and are checked by default depends on the
           distribution you use.

       The following options are valid within Key blocks:

       Type Type
           Sets the type used to dispatch the values to the daemon. Detailed
           information about types and their configuration can be found in
           types.db(5). This option is mandatory.

       Instance Instance
           Type-instance to use. Defaults to the current map key or current
           string array element value.

   Plugin "curl_xml"
       The curl_xml plugin uses libcurl (<http://curl.haxx.se/>) and libxml2
       (<http://xmlsoft.org/>) to retrieve XML data via cURL.








4.10.2                      2010-11-27                         11





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


        <Plugin "curl_xml">
          <URL "http://localhost/stats.xml">
            Host "my_host"
            Instance "some_instance"
            User "collectd"
            Password "thaiNg0I"
            VerifyPeer true
            VerifyHost true
            CACert "/path/to/ca.crt"

            <XPath "table[@id=\"magic_level\"]/tr">
              Type "magic_level"
              #InstancePrefix "prefix-"
              InstanceFrom "td[1]"
              ValuesFrom "td[2]/span[@class=\"level\"]"
            </XPath>
          </URL>
        </Plugin>

       In the Plugin block, there may be one or more URL blocks, each defining
       a URL to be fetched via HTTP (using libcurl). Within each URL block
       there are options which specify the connection parameters, for example
       authentication information, and one or more XPath blocks.

       Each XPath block specifies how to get one type of information. The
       string argument must be a valid XPath expression which returns a list
       of "base elements". One value is dispatched for each "base element".
       The type instance and values are looked up using further XPath
       expressions that should be relative to the base element.

       Within the URL block the following options are accepted:

       Host Name
           Use Name as the host name when submitting values. Defaults to the
           global host name setting.

       Instance Instance
           Use Instance as the plugin instance when submitting values.
           Defaults to an empty string (no plugin instance).

       User User =item Password Password =item VerifyPeer true|false =item
       VerifyHost true|false =item CACert CA Cert File
           These options behave exactly equivalent to the appropriate options
           of the cURL and cURL-JSON plugins. Please see there for a detailed
           description.

       <XPath XPath-expression>
           Within each URL block, there must be one or more XPath blocks. Each
           XPath block specifies how to get one type of information. The
           string argument must be a valid XPath expression which returns a
           list of "base elements". One value is dispatched for each "base
           element".

           Within the XPath block the following options are accepted:



4.10.2                      2010-11-27                         12





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


           Type Type
               Specifies the Type used for submitting patches. This determines
               the number of values that are required / expected and whether
               the strings are parsed as signed or unsigned integer or as
               double values. See types.db(5) for details.  This option is
               required.

           InstancePrefix InstancePrefix
               Prefix the type instance with InstancePrefix. The values are
               simply concatenated together without any separator.  This
               option is optional.

           InstanceFrom InstanceFrom
               Specifies a XPath expression to use for determining the type
               instance. The XPath expression must return exactly one element.
               The element's value is then used as type instance, possibly
               prefixed with InstancePrefix (see above).

               This value is required. As a special exception, if the "base
               XPath expression" (the argument to the XPath block) returns
               exactly one argument, then this option may be omitted.

           ValuesFrom ValuesFrom [ValuesFrom ...]
               Specifies one or more XPath expression to use for reading the
               values. The number of XPath expressions must match the number
               of data sources in the type specified with Type (see above).
               Each XPath expression must return exactly one element. The
               element's value is then parsed as a number and used as value
               for the appropriate value in the value list dispatched to the
               daemon.

   Plugin "dbi"
       This plugin uses the dbi library (<http://libdbi.sourceforge.net/>) to
       connect to various databases, execute SQL statements and read back the
       results. dbi is an acronym for "database interface" in case you were
       wondering about the name. You can configure how each column is to be
       interpreted and the plugin will generate one or more data sets from
       each row returned according to these rules.

       Because the plugin is very generic, the configuration is a little more
       complex than those of other plugins. It usually looks something like
       this:

         <Plugin dbi>
           <Query "out_of_stock">
             Statement "SELECT category, COUNT(*) AS value FROM products WHERE in_stock = 0 GROUP BY category"
             # Use with MySQL 5.0.0 or later
             MinVersion 50000
             <Result>
               Type "gauge"
               InstancePrefix "out_of_stock"
               InstancesFrom "category"
               ValuesFrom "value"
             </Result>



4.10.2                      2010-11-27                         13





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


           </Query>
           <Database "product_information">
             Driver "mysql"
             DriverOption "host" "localhost"
             DriverOption "username" "collectd"
             DriverOption "password" "aZo6daiw"
             DriverOption "dbname" "prod_info"
             SelectDB "prod_info"
             Query "out_of_stock"
           </Database>
         </Plugin>

       The configuration above defines one query with one result and one
       database. The query is then linked to the database with the Query
       option within the <Database> block. You can have any number of queries
       and databases and you can also use the Include statement to split up
       the configuration file in multiple, smaller files. However, the <Query>
       block must precede the <Database> blocks, because the file is
       interpreted from top to bottom!

       The following is a complete list of options:

       Query blocks

       Query blocks define SQL statements and how the returned data should be
       interpreted. They are identified by the name that is given in the
       opening line of the block. Thus the name needs to be unique. Other than
       that, the name is not used in collectd.

       In each Query block, there is one or more Result blocks. Result blocks
       define which column holds which value or instance information. You can
       use multiple Result blocks to create multiple values from one returned
       row. This is especially useful, when queries take a long time and
       sending almost the same query again and again is not desirable.

       Example:

         <Query "environment">
           Statement "select station, temperature, humidity from environment"
           <Result>
             Type "temperature"
             # InstancePrefix "foo"
             InstancesFrom "station"
             ValuesFrom "temperature"
           </Result>
           <Result>
             Type "humidity"
             InstancesFrom "station"
             ValuesFrom "humidity"
           </Result>
         </Query>

       The following options are accepted:




4.10.2                      2010-11-27                         14





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       Statement SQL
           Sets the statement that should be executed on the server. This is
           not interpreted by collectd, but simply passed to the database
           server. Therefore, the SQL dialect that's used depends on the
           server collectd is connected to.

           The query has to return at least two columns, one for the instance
           and one value. You cannot omit the instance, even if the statement
           is guaranteed to always return exactly one line. In that case, you
           can usually specify something like this:

             Statement "SELECT \"instance\", COUNT(*) AS value FROM table"

           (That works with MySQL but may not be valid SQL according to the
           spec. If you use a more strict database server, you may have to
           select from a dummy table or something.)

           Please note that some databases, for example Oracle, will fail if
           you include a semicolon at the end of the statement.

       MinVersion Version
       MaxVersion Value
           Only use this query for the specified database version. You can use
           these options to provide multiple queries with the same name but
           with a slightly different syntax. The plugin will use only those
           queries, where the specified minimum and maximum versions fit the
           version of the database in use.

           The database version is determined by
           "dbi_conn_get_engine_version", see the <libdbi documentation> for
           details. Basically, each part of the version is assumed to be in
           the range from 00 to 99 and all dots are removed. So version
           "4.1.2" becomes "40102", version "5.0.42" becomes "50042".

           Warning: The plugin will use all matching queries, so if you
           specify multiple queries with the same name and overlapping ranges,
           weird stuff will happen. Don't to it! A valid example would be
           something along these lines:

             MinVersion 40000
             MaxVersion 49999
             ...
             MinVersion 50000
             MaxVersion 50099
             ...
             MinVersion 50100
             # No maximum

           In the above example, there are three ranges that don't overlap.
           The last one goes from version "5.1.0" to infinity, meaning "all
           later versions". Versions before "4.0.0" are not specified.

       Type Type
           The type that's used for each line returned. See types.db(5) for



4.10.2                      2010-11-27                         15





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


           more details on how types are defined. In short: A type is a
           predefined layout of data and the number of values and type of
           values has to match the type definition.

           If you specify "temperature" here, you need exactly one gauge
           column. If you specify "if_octets", you will need two counter
           columns. See the ValuesFrom setting below.

           There must be exactly one Type option inside each Result block.

       InstancePrefix prefix
           Prepends prefix to the type instance. If InstancesFrom (see below)
           is not given, the string is simply copied. If InstancesFrom is
           given, prefix and all strings returned in the appropriate columns
           are concatenated together, separated by dashes ("-").

       InstancesFrom column0 [column1 ...]
           Specifies the columns whose values will be used to create the
           "type-instance" for each row. If you specify more than one column,
           the value of all columns will be joined together with dashes ("-")
           as separation characters.

           The plugin itself does not check whether or not all built instances
           are different. It's your responsibility to assure that each is
           unique. This is especially true, if you do not specify
           InstancesFrom: You have to make sure that only one row is returned
           in this case.

           If neither InstancePrefix nor InstancesFrom is given, the type-
           instance will be empty.

       ValuesFrom column0 [column1 ...]
           Names the columns whose content is used as the actual data for the
           data sets that are dispatched to the daemon. How many such columns
           you need is determined by the Type setting above. If you specify
           too many or not enough columns, the plugin will complain about that
           and no data will be submitted to the daemon.

           The actual data type in the columns is not that important. The
           plugin will automatically cast the values to the right type if it
           know how to do that. So it should be able to handle integer an
           floating point types, as well as strings (if they include a number
           at the beginning).

           There must be at least one ValuesFrom option inside each Result
           block.

       Database blocks

       Database blocks define a connection to a database and which queries
       should be sent to that database. Since the used "dbi" library can
       handle a wide variety of databases, the configuration is very generic.
       If in doubt, refer to libdbi's documentation - we stick as close to the
       terminology used there.



4.10.2                      2010-11-27                         16





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       Each database needs a "name" as string argument in the starting tag of
       the block. This name will be used as "PluginInstance" in the values
       submitted to the daemon. Other than that, that name is not used.

       Driver Driver
           Specifies the driver to use to connect to the database. In many
           cases those drivers are named after the database they can connect
           to, but this is not a technical necessity. These drivers are
           sometimes referred to as "DBD", DataBase Driver, and some
           distributions ship them in separate packages. Drivers for the "dbi"
           library are developed by the libdbi-drivers project at
           <http://libdbi-drivers.sourceforge.net/>.

           You need to give the driver name as expected by the "dbi" library
           here. You should be able to find that in the documentation for each
           driver. If you mistype the driver name, the plugin will dump a list
           of all known driver names to the log.

       DriverOption Key Value
           Sets driver-specific options. What option a driver supports can be
           found in the documentation for each driver, somewhere at
           <http://libdbi-drivers.sourceforge.net/>. However, the options
           "host", "username", "password", and "dbname" seem to be de facto
           standards.

           Unfortunately, drivers are not too keen to report errors when an
           unknown option is passed to them, so invalid settings here may go
           unnoticed. This is not the plugin's fault, it will report errors if
           it gets them from the library / the driver. If a driver complains
           about an option, the plugin will dump a complete list of all
           options understood by that driver to the log.

       SelectDB Database
           In some cases, the database name you connect with is not the
           database name you want to use for querying data. If this option is
           set, the plugin will "select" (switch to) that database after the
           connection is established.

       Query QueryName
           Associates the query named QueryName with this database connection.
           The query needs to be defined before this statement, i. e. all
           query blocks you want to refer to must be placed above the database
           block you want to refer to them from.

   Plugin "df"
       Device Device
           Select partitions based on the devicename.

       MountPoint Directory
           Select partitions based on the mountpoint.

       FSType FSType
           Select partitions based on the filesystem type.




4.10.2                      2010-11-27                         17





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       IgnoreSelected true|false
           Invert the selection: If set to true, all partitions except the
           ones that match any one of the criteria are collected. By default
           only selected partitions are collected if a selection is made. If
           no selection is configured at all, all partitions are selected.

       ReportByDevice true|false
           Report using the device name rather than the mountpoint. i.e. with
           this false, (the default), it will report a disk as "root", but
           with it true, it will be "sda1" (or whichever).

       ReportReserved true|false
           When enabled, the blocks reserved for root are reported separately.
           When disabled (the default for backwards compatibility reasons) the
           reserved space will be included in the "free" space.

           When disabled, the "df" type will be used to store "free" and
           "used" space. The mount point or disk name (see option
           ReportByDevice) is used as type instance in this case (again:
           backwards compatibility).

           When enabled, the type "df_complex" is used and three files are
           created. The mount point or disk name is used as plugin instance
           and the type instance is set to "free", "reserved" and "used" as
           appropriate.

           Enabling this option is recommended.

       ReportInodes true|false
           Enables or disables reporting of free, reserved and used inodes.
           Defaults to inode collection being disabled.

           Enable this option if inodes are a scarce resource for you, usually
           because many small files are stored on the disk. This is a usual
           scenario for mail transfer agents and web caches.

   Plugin "disk"
       The "disk" plugin collects information about the usage of physical
       disks and logical disks (partitions). Values collected are the number
       of octets written to and read from a disk or partition, the number of
       read/write operations issued to the disk and a rather complex "time" it
       took for these commands to be issued.

       Using the following two options you can ignore some disks or configure
       the collection only of specific disks.

       Disk Name
           Select the disk Name. Whether it is collected or ignored depends on
           the IgnoreSelected setting, see below. As with other plugins that
           use the daemon's ignorelist functionality, a string that starts and
           ends with a slash is interpreted as a regular expression. Examples:

             Disk "sdd"
             Disk "/hda[34]/"



4.10.2                      2010-11-27                         18





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       IgnoreSelected true|false
           Sets whether selected disks, i. e. the ones matches by any of the
           Disk statements, are ignored or if all other disks are ignored. The
           behavior (hopefully) is intuitive: If no Disk option is configured,
           all disks are collected. If at least one Disk option is given and
           no IgnoreSelected or set to false, only matching disks will be
           collected. If IgnoreSelected is set to true, all disks are
           collected except the ones matched.

   Plugin "dns"
       Interface Interface
           The dns plugin uses libpcap to capture dns traffic and analyzes it.
           This option sets the interface that should be used. If this option
           is not set, or set to "any", the plugin will try to get packets
           from all interfaces. This may not work on certain platforms, such
           as Mac OS X.

       IgnoreSource IP-address
           Ignore packets that originate from this address.

       SelectNumericQueryTypes true|false
           Enabled by default, collects unknown (and thus presented as numeric
           only) query types.

   Plugin "email"
       SocketFile Path
           Sets the socket-file which is to be created.

       SocketGroup Group
           If running as root change the group of the UNIX-socket after it has
           been created. Defaults to collectd.

       SocketPerms Permissions
           Change the file permissions of the UNIX-socket after it has been
           created. The permissions must be given as a numeric, octal value as
           you would pass to chmod(1). Defaults to 0770.

       MaxConns Number
           Sets the maximum number of connections that can be handled in
           parallel. Since this many threads will be started immediately
           setting this to a very high value will waste valuable resources.
           Defaults to 5 and will be forced to be at most 16384 to prevent
           typos and dumb mistakes.

   Plugin "exec"
       Please make sure to read collectd-exec(5) before using this plugin. It
       contains valuable information on when the executable is executed and
       the output that is expected from it.

       Exec User[:[Group]] Executable [<arg> [<arg> ...]]
       NotificationExec User[:[Group]] Executable [<arg> [<arg> ...]]
           Execute the executable Executable as user User. If the user name is
           followed by a colon and a group name, the effective group is set to
           that group.  The real group and saved-set group will be set to the



4.10.2                      2010-11-27                         19





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


           default group of that user. If no group is given the effective
           group ID will be the same as the real group ID.

           Please note that in order to change the user and/or group the
           daemon needs superuser privileges. If the daemon is run as an
           unprivileged user you must specify the same user/group here. If the
           daemon is run with superuser privileges, you must supply a non-root
           user here.

           The executable may be followed by optional arguments that are
           passed to the program. Please note that due to the configuration
           parsing numbers and boolean values may be changed. If you want to
           be absolutely sure that something is passed as-is please enclose it
           in quotes.

           The Exec and NotificationExec statements change the semantics of
           the programs executed, i. e. the data passed to them and the
           response expected from them. This is documented in great detail in
           collectd-exec(5).

   Plugin "filecount"
       The "filecount" plugin counts the number of files in a certain
       directory (and its subdirectories) and their combined size. The
       configuration is very straight forward:

         <Plugin "filecount">
           <Directory "/var/qmail/queue/mess">
             Instance "qmail-message"
           </Directory>
           <Directory "/var/qmail/queue/todo">
             Instance "qmail-todo"
           </Directory>
           <Directory "/var/lib/php5">
             Instance "php5-sessions"
             Name "sess_*"
           </Directory>
         </Plugin>

       The example above counts the number of files in QMail's queue
       directories and the number of PHP5 sessions. Jfiy: The "todo" queue
       holds the messages that QMail has not yet looked at, the "message"
       queue holds the messages that were classified into "local" and
       "remote".

       As you can see, the configuration consists of one or more "Directory"
       blocks, each of which specifies a directory in which to count the
       files. Within those blocks, the following options are recognized:

       Instance Instance
           Sets the plugin instance to Instance. That instance name must be
           unique, but it's your responsibility, the plugin doesn't check for
           that. If not given, the instance is set to the directory name with
           all slashes replaced by underscores and all leading underscores
           removed.



4.10.2                      2010-11-27                         20





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       Name Pattern
           Only count files that match Pattern, where Pattern is a shell-like
           wildcard as understood by fnmatch(3). Only the filename is checked
           against the pattern, not the entire path. In case this makes it
           easier for you: This option has been named after the -name
           parameter to find(1).

       MTime Age
           Count only files of a specific age: If Age is greater than zero,
           only files that haven't been touched in the last Age seconds are
           counted. If Age is a negative number, this is inversed. For
           example, if -60 is specified, only files that have been modified in
           the last minute will be counted.

           The number can also be followed by a "multiplier" to easily specify
           a larger timespan. When given in this notation, the argument must
           in quoted, i. e.  must be passed as string. So the -60 could also
           be written as "-1m" (one minute). Valid multipliers are "s"
           (second), "m" (minute), "h" (hour), "d" (day), "w" (week), and "y"
           (year). There is no "month" multiplier. You can also specify
           fractional numbers, e. g. "0.5d" is identical to "12h".

       Size Size
           Count only files of a specific size. When Size is a positive
           number, only files that are at least this big are counted. If Size
           is a negative number, this is inversed, i. e. only files smaller
           than the absolute value of Size are counted.

           As with the MTime option, a "multiplier" may be added. For a
           detailed description see above. Valid multipliers here are "b"
           (byte), "k" (kilobyte), "m" (megabyte), "g" (gigabyte), "t"
           (terabyte), and "p" (petabyte). Please note that there are 1000
           bytes in a kilobyte, not 1024.

       Recursive true|false
           Controls whether or not to recurse into subdirectories. Enabled by
           default.

       IncludeHidden true|false
           Controls whether or not to include "hidden" files and directories
           in the count.  "Hidden" files and directories are those, whose name
           begins with a dot.  Defaults to false, i.e. by default hidden files
           and directories are ignored.

   Plugin "GenericJMX"
       The GenericJMX plugin is written in Java and therefore documented in
       collectd-java(5).

   Plugin "gmond"
       The gmond plugin received the multicast traffic sent by gmond, the
       statistics collection daemon of Ganglia. Mappings for the standard
       "metrics" are built-in, custom mappings may be added via Metric blocks,
       see below.




4.10.2                      2010-11-27                         21





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       Synopsis:

        <Plugin "gmond">
          MCReceiveFrom "239.2.11.71" "8649"
          <Metric "swap_total">
            Type "swap"
            TypeInstance "total"
            DataSource "value"
          </Metric>
          <Metric "swap_free">
            Type "swap"
            TypeInstance "free"
            DataSource "value"
          </Metric>
        </Plugin>

       The following metrics are built-in:

       o   load_one, load_five, load_fifteen

       o   cpu_user, cpu_system, cpu_idle, cpu_nice, cpu_wio

       o   mem_free, mem_shared, mem_buffers, mem_cached, mem_total

       o   bytes_in, bytes_out

       o   pkts_in, pkts_out

       Available configuration options:

       MCReceiveFrom MCGroup [Port]
           Sets sets the multicast group and UDP port to which to subscribe.

           Default: 239.2.11.71 / 8649

       <Metric Name>
           These blocks add a new metric conversion to the internal table.
           Name, the string argument to the Metric block, is the metric name
           as used by Ganglia.

           Type Type
               Type to map this metric to. Required.

           TypeInstance Instance
               Type-instance to use. Optional.

           DataSource Name
               Data source to map this metric to. If the configured type has
               exactly one data source, this is optional. Otherwise the option
               is required.

   Plugin "hddtemp"
       To get values from hddtemp collectd connects to localhost (127.0.0.1),
       port 7634/tcp. The Host and Port options can be used to change these



4.10.2                      2010-11-27                         22





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       default values, see below. "hddtemp" has to be running to work
       correctly. If "hddtemp" is not running timeouts may appear which may
       interfere with other statistics..

       The hddtemp homepage can be found at
       <http://www.guzu.net/linux/hddtemp.php>.

       Host Hostname
           Hostname to connect to. Defaults to 127.0.0.1.

       Port Port
           TCP-Port to connect to. Defaults to 7634.

       TranslateDevicename true|false
           If enabled, translate the disk names to major/minor device numbers
           (e. g. "8-0" for /dev/sda). For backwards compatibility this
           defaults to true but it's recommended to disable it as it will
           probably be removed in the next major version.

   Plugin "interface"
       Interface Interface
           Select this interface. By default these interfaces will then be
           collected. For a more detailed description see IgnoreSelected
           below.

       IgnoreSelected true|false
           If no configuration if given, the traffic-plugin will collect data
           from all interfaces. This may not be practical, especially for
           loopback- and similar interfaces. Thus, you can use the
           Interface-option to pick the interfaces you're interested in.
           Sometimes, however, it's easier/preferred to collect all interfaces
           except a few ones. This option enables you to do that: By setting
           IgnoreSelected to true the effect of Interface is inverted: All
           selected interfaces are ignored and all other interfaces are
           collected.

   Plugin "ipmi"
       Sensor Sensor
           Selects sensors to collect or to ignore, depending on
           IgnoreSelected.

       IgnoreSelected true|false
           If no configuration if given, the ipmi plugin will collect data
           from all sensors found of type "temperature", "voltage", "current"
           and "fanspeed".  This option enables you to do that: By setting
           IgnoreSelected to true the effect of Sensor is inverted: All
           selected sensors are ignored and all other sensors are collected.

       NotifySensorAdd true|false
           If a sensor appears after initialization time of a minute a
           notification is sent.

       NotifySensorRemove true|false
           If a sensor disappears a notification is sent.



4.10.2                      2010-11-27                         23





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       NotifySensorNotPresent true|false
           If you have for example dual power supply and one of them is
           (un)plugged then a notification is sent.

   Plugin "iptables"
       Chain Table Chain [Comment|Number [Name]]
           Select the rules to count. If only Table and Chain are given, this
           plugin will collect the counters of all rules which have a comment-
           match. The comment is then used as type-instance.

           If Comment or Number is given, only the rule with the matching
           comment or the nth rule will be collected. Again, the comment (or
           the number) will be used as the type-instance.

           If Name is supplied, it will be used as the type-instance instead
           of the comment or the number.

   Plugin "irq"
       Irq Irq
           Select this irq. By default these irqs will then be collected. For
           a more detailed description see IgnoreSelected below.

       IgnoreSelected true|false
           If no configuration if given, the irq-plugin will collect data from
           all irqs. This may not be practical, especially if no interrupts
           happen. Thus, you can use the Irq-option to pick the interrupt
           you're interested in.  Sometimes, however, it's easier/preferred to
           collect all interrupts except a few ones. This option enables you
           to do that: By setting IgnoreSelected to true the effect of Irq is
           inverted: All selected interrupts are ignored and all other
           interrupts are collected.

   Plugin "java"
       The Java plugin makes it possible to write extensions for collectd in
       Java.  This section only discusses the syntax and semantic of the
       configuration options. For more in-depth information on the Java
       plugin, please read collectd-java(5).

       Synopsis:

        <Plugin "java">
          JVMArg "-verbose:jni"
          JVMArg "-Djava.class.path=/opt/collectd/lib/collectd/bindings/java"
          LoadPlugin "org.collectd.java.Foobar"
          <Plugin "org.collectd.java.Foobar">
            # To be parsed by the plugin
          </Plugin>
        </Plugin>

       Available configuration options:

       JVMArg Argument
           Argument that is to be passed to the Java Virtual Machine (JVM).
           This works exactly the way the arguments to the java binary on the



4.10.2                      2010-11-27                         24





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


           command line work.  Execute "java --help" for details.

           Please note that all these options must appear before (i. e. above)
           any other options! When another option is found, the JVM will be
           started and later options will have to be ignored!

       LoadPlugin JavaClass
           Instantiates a new JavaClass object. The constructor of this object
           very likely then registers one or more callback methods with the
           server.

           See collectd-java(5) for details.

           When the first such option is found, the virtual machine (JVM) is
           created. This means that all JVMArg options must appear before
           (i. e. above) all LoadPlugin options!

       Plugin Name
           The entire block is passed to the Java plugin as an
           org.collectd.api.OConfigItem object.

           For this to work, the plugin has to register a configuration
           callback first, see "config callback" in collectd-java(5). This
           means, that the Plugin block must appear after the appropriate
           LoadPlugin block. Also note, that Name depends on the (Java) plugin
           registering the callback and is completely independent from the
           JavaClass argument passed to LoadPlugin.

   Plugin "libvirt"
       This plugin allows CPU, disk and network load to be collected for
       virtualized guests on the machine. This means that these
       characteristics can be collected for guest systems without installing
       any software on them - collectd only runs on the hosting system. The
       statistics are collected through libvirt (<http://libvirt.org/>).

       Only Connection is required.

       Connection uri
           Connect to the hypervisor given by uri. For example if using Xen
           use:

            Connection "xen:///"

           Details which URIs allowed are given at
           <http://libvirt.org/uri.html>.

       RefreshInterval seconds
           Refresh the list of domains and devices every seconds. The default
           is 60 seconds. Setting this to be the same or smaller than the
           Interval will cause the list of domains and devices to be refreshed
           on every iteration.

           Refreshing the devices in particular is quite a costly operation,
           so if your virtualization setup is static you might consider



4.10.2                      2010-11-27                         25





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


           increasing this. If this option is set to 0, refreshing is disabled
           completely.

       Domain name
       BlockDevice name:dev
       InterfaceDevice name:dev
       IgnoreSelected true|false
           Select which domains and devices are collected.

           If IgnoreSelected is not given or false then only the listed
           domains and disk/network devices are collected.

           If IgnoreSelected is true then the test is reversed and the listed
           domains and disk/network devices are ignored, while the rest are
           collected.

           The domain name and device names may use a regular expression, if
           the name is surrounded by /.../ and collectd was compiled with
           support for regexps.

           The default is to collect statistics for all domains and all their
           devices.

           Example:

            BlockDevice "/:hdb/"
            IgnoreSelected "true"

           Ignore all hdb devices on any domain, but other block devices (eg.
           hda) will be collected.

       HostnameFormat name|uuid|hostname|...
           When the libvirt plugin logs data, it sets the hostname of the
           collected data according to this setting. The default is to use the
           guest name as provided by the hypervisor, which is equal to setting
           name.

           uuid means use the guest's UUID. This is useful if you want to
           track the same guest across migrations.

           hostname means to use the global Hostname setting, which is
           probably not useful on its own because all guests will appear to
           have the same name.

           You can also specify combinations of these fields. For example name
           uuid means to concatenate the guest name and UUID (with a literal
           colon character between, thus "foo:1234-1234-1234-1234").

   Plugin "logfile"
       LogLevel debug|info|notice|warning|err
           Sets the log-level. If, for example, set to notice, then all events
           with severity notice, warning, or err will be written to the
           logfile.




4.10.2                      2010-11-27                         26





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


           Please note that debug is only available if collectd has been
           compiled with debugging support.

       File File
           Sets the file to write log messages to. The special strings stdout
           and stderr can be used to write to the standard output and standard
           error channels, respectively. This, of course, only makes much
           sense when collectd is running in foreground- or non-daemon-mode.

       Timestamp true|false
           Prefix all lines printed by the current time. Defaults to true.

       PrintSeverity true|false
           When enabled, all lines are prefixed by the severity of the log
           message, for example "warning". Defaults to false.

       Note: There is no need to notify the daemon after moving or removing
       the log file (e. g. when rotating the logs). The plugin reopens the
       file for each line it writes.

   Plugin "mbmon"
       The "mbmon plugin" uses mbmon to retrieve temperature, voltage, etc.

       Be default collectd connects to localhost (127.0.0.1), port 411/tcp.
       The Host and Port options can be used to change these values, see
       below.  "mbmon" has to be running to work correctly. If "mbmon" is not
       running timeouts may appear which may interfere with other statistics..

       "mbmon" must be run with the -r option ("print TAG and Value format");
       Debian's /etc/init.d/mbmon script already does this, other people will
       need to ensure that this is the case.

       Host Hostname
           Hostname to connect to. Defaults to 127.0.0.1.

       Port Port
           TCP-Port to connect to. Defaults to 411.

   Plugin "memcachec"
       The "memcachec plugin" connects to a memcached server, queries one or
       more given pages and parses the returned data according to user
       specification.  The matches used are the same as the matches used in
       the "curl" and "tail" plugins.

       In order to talk to the memcached server, this plugin uses the
       libmemcached library. Please note that there is another library with a
       very similar name, libmemcache (notice the missing `d'), which is not
       applicable.

       Synopsis of the configuration:







4.10.2                      2010-11-27                         27





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


        <Plugin "memcachec">
          <Page "plugin_instance">
            Server "localhost"
            Key "page_key"
            <Match>
              Regex "(\\d+) bytes sent"
              DSType CounterAdd
              Type "ipt_octets"
              Instance "type_instance"
            </Match>
          </Page>
        </Plugin>

       The configuration options are:

       <Page Name>
           Each Page block defines one page to be queried from the memcached
           server.  The block requires one string argument which is used as
           plugin instance.

       Server Address
           Sets the server address to connect to when querying the page. Must
           be inside a Page block.

       Key Key
           When connected to the memcached server, asks for the page Key.

       <Match>
           Match blocks define which strings to look for and how matches
           substrings are interpreted. For a description of match blocks,
           please see "Plugin tail".

   Plugin "memcached"
       The "memcached plugin" connects to a memcached server and queries
       statistics about cache utilization, memory and bandwidth used.
       <http://www.danga.com/memcached/>

       Host Hostname
           Hostname to connect to. Defaults to 127.0.0.1.

       Port Port
           TCP-Port to connect to. Defaults to 11211.

   Plugin "modbus"
       The modbus plugin connects to a Modbus "slave" via Modbus/TCP and reads
       register values. It supports reading single registers (unsigned 16 bit
       values), large integer values (unsigned 32 bit values) and floating
       point values (two registers interpreted as IEEE floats in big endian
       notation).

       Synopsis:






4.10.2                      2010-11-27                         28





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


        <Data "voltage-input-1">
          RegisterBase 0
          RegisterType float
          Type voltage
          Instance "input-1"
        </Data>

        <Data "voltage-input-2">
          RegisterBase 2
          RegisterType float
          Type voltage
          Instance "input-2"
        </Data>

        <Host "modbus.example.com">
          Address "192.168.0.42"
          Port    "502"
          Interval 60

          <Slave 1>
            Instance "power-supply"
            Collect  "voltage-input-1"
            Collect  "voltage-input-2"
          </Slave>
        </Host>

       <Data Name> blocks
           Data blocks define a mapping between register numbers and the
           "types" used by collectd.

           Within <Data /> blocks, the following options are allowed:

           RegisterBase Number
               Configures the base register to read from the device. If the
               option RegisterType has been set to Uint32 or Float, this and
               the next register will be read (the register number is
               increased by one).

           RegisterType Uint16|Uint32|Float
               Specifies what kind of data is returned by the device. If the
               type is Uint32 or Float, two 16 bit registers will be read and
               the data is combined into one value. Defaults to Uint16.

           Type Type
               Specifies the "type" (data set) to use when dispatching the
               value to collectd. Currently, only data sets with exactly one
               data source are supported.

           Instance Instance
               Sets the type instance to use when dispatching the value to
               collectd. If unset, an empty string (no type instance) is used.

       <Host Name> blocks
           Host blocks are used to specify to which hosts to connect and what



4.10.2                      2010-11-27                         29





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


           data to read from their "slaves". The string argument Name is used
           as hostname when dispatching the values to collectd.

           Within <Host /> blocks, the following options are allowed:

           Address Hostname
               Specifies the node name (the actual network address) used to
               connect to the host. This may be an IP address or a hostname.
               Please note that the used libmodbus library only supports IPv4
               at the moment.

           Port Service
               Specifies the port used to connect to the host. The port can
               either be given as a number or as a service name. Please note
               that the Service argument must be a string, even if ports are
               given in their numerical form. Defaults to "502".

           Interval Interval
               Sets the interval (in seconds) in which the values will be
               collected from this host. By default the global Interval
               setting will be used.

           <Slave ID>
               Over each TCP connection, multiple Modbus devices may be
               reached. The slave ID is used to specify which device should be
               addressed. For each device you want to query, one Slave block
               must be given.

               Within <Slave /> blocks, the following options are allowed:

               Instance Instance
                   Specify the plugin instance to use when dispatching the
                   values to collectd.  By default "slave_ID" is used.

               Collect DataName
                   Specifies which data to retrieve from the device. DataName
                   must be the same string as the Name argument passed to a
                   Data block. You can specify this option multiple times to
                   collect more than one value from a slave. At least one
                   Collect option is mandatory.

   Plugin "mysql"
       The "mysql plugin" requires mysqlclient to be installed. It connects to
       one or more databases when started and keeps the connection up as long
       as possible. When the connection is interrupted for whatever reason it
       will try to re-connect. The plugin will complaint loudly in case
       anything goes wrong.

       This plugin issues the MySQL "SHOW STATUS" / "SHOW GLOBAL STATUS"
       command and collects information about MySQL network traffic, executed
       statements, requests, the query cache and threads by evaluating the
       "Bytes_{received,sent}", "Com_*", "Handler_*", "Qcache_*" and
       "Threads_*" return values. Please refer to the MySQL reference manual,
       5.1.6. Server Status Variables for an explanation of these values.



4.10.2                      2010-11-27                         30





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       Optionally, master and slave statistics may be collected in a MySQL
       replication setup. In that case, information about the synchronization
       state of the nodes are collected by evaluating the "Position" return
       value of the "SHOW MASTER STATUS" command and the
       "Seconds_Behind_Master", "Read_Master_Log_Pos" and
       "Exec_Master_Log_Pos" return values of the "SHOW SLAVE STATUS" command.
       See the MySQL reference manual, 12.5.5.21 SHOW MASTER STATUS Syntax and
       12.5.5.31 SHOW SLAVE STATUS Syntax for details.

       Synopsis:

         <Plugin mysql>
           <Database foo>
             Host "hostname"
             User "username"
             Password "password"
             Port "3306"
             MasterStats true
           </Database>

           <Database bar>
             Host "localhost"
             Socket "/var/run/mysql/mysqld.sock"
             SlaveStats true
             SlaveNotifications true
           </Database>
         </Plugin>

       A Database block defines one connection to a MySQL database. It accepts
       a single argument which specifies the name of the database. None of the
       other options are required. MySQL will use default values as documented
       in the section "mysql_real_connect()" in the MySQL reference manual.

       Host Hostname
           Hostname of the database server. Defaults to localhost.

       User Username
           Username to use when connecting to the database. The user does not
           have to be granted any privileges (which is synonym to granting the
           "USAGE" privilege).  Any existing MySQL user will do.

       Password Password
           Password needed to log into the database.

       Database Database
           Select this database. Defaults to no database which is a perfectly
           reasonable option for what this plugin does.

       Port Port
           TCP-port to connect to. The port must be specified in its numeric
           form, but it must be passed as a string nonetheless. For example:

             Port "3306"




4.10.2                      2010-11-27                         31





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


           If Host is set to localhost (the default), this setting has no
           effect.  See the documentation for the "mysql_real_connect"
           function for details.

       Socket Socket
           Specifies the path to the UNIX domain socket of the MySQL server.
           This option only has any effect, if Host is set to localhost (the
           default).  Otherwise, use the Port option above. See the
           documentation for the "mysql_real_connect" function for details.

       MasterStats true|false
       SlaveStats true|false
           Enable the collection of master / slave statistics in a replication
           setup.

       SlaveNotifications true|false
           If enabled, the plugin sends a notification if the replication
           slave I/O and / or SQL threads are not running.

   Plugin "netapp"
       The netapp plugin can collect various performance and capacity
       information from a NetApp filer using the NetApp API.

       Please note that NetApp has a wide line of products and a lot of
       different software versions for each of these products. This plugin was
       developed for a NetApp FAS3040 running OnTap 7.2.3P8 and tested on
       FAS2050 7.3.1.1L1, FAS3140 7.2.5.1 and FAS3020 7.2.4P9. It should work
       for most combinations of model and software version but it is very hard
       to test this.  If you have used this plugin with other models and/or
       software version, feel free to send us a mail to tell us about the
       results, even if it's just a short "It works".

       To collect these data collectd will log in to the NetApp via HTTP(S)
       and HTTP basic authentication.

       Do not use a regular user for this! Create a special collectd user with
       just the minimum of capabilities needed. The user only needs the
       "login-http-admin" capability as well as a few more depending on which
       data will be collected.  Required capabilities are documented below.

       Synopsis

        <Plugin "netapp">
          <Host "netapp1.example.com">
           Protocol      "https"
           Address       "10.0.0.1"
           Port          443
           User          "username"
           Password      "aef4Aebe"
           Interval      30

           <WAFL>
             Interval 30
             GetNameCache   true



4.10.2                      2010-11-27                         32





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


             GetDirCache    true
             GetBufferCache true
             GetInodeCache  true
           </WAFL>

           <Disks>
             Interval 30
             GetBusy true
           </Disks>

           <VolumePerf>
             Interval 30
             GetIO      "volume0"
             IgnoreSelectedIO      false
             GetOps     "volume0"
             IgnoreSelectedOps     false
             GetLatency "volume0"
             IgnoreSelectedLatency false
           </VolumePerf>

           <VolumeUsage>
             Interval 30
             GetCapacity "vol0"
             GetCapacity "vol1"
             IgnoreSelectedCapacity false
             GetSnapshot "vol1"
             GetSnapshot "vol3"
             IgnoreSelectedSnapshot false
           </VolumeUsage>

           <System>
             Interval 30
             GetCPULoad     true
             GetInterfaces  true
             GetDiskOps     true
             GetDiskIO      true
           </System>
          </Host>
        </Plugin>

       The netapp plugin accepts the following configuration options:

       Host Name
           A host block defines one NetApp filer. It will appear in collectd
           with the name you specify here which does not have to be its real
           name nor its hostname.

       Protocol httpd|http
           The protocol collectd will use to query this host.

           Optional

           Type: string




4.10.2                      2010-11-27                         33





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


           Default: https

           Valid options: http, https

       Address Address
           The hostname or IP address of the host.

           Optional

           Type: string

           Default: The "host" block's name.

       Port Port
           The TCP port to connect to on the host.

           Optional

           Type: integer

           Default: 80 for protocol "http", 443 for protocol "https"

       User User
       Password Password
           The username and password to use to login to the NetApp.

           Mandatory

           Type: string

       Interval Interval
           TODO

       The following options decide what kind of data will be collected. You
       can either use them as a block and fine tune various parameters inside
       this block, use them as a single statement to just accept all default
       values, or omit it to not collect any data.

       The following options are valid inside all blocks:

       Interval Seconds
           Collect the respective statistics every Seconds seconds. Defaults
           to the host specific setting.

       The System block

       This will collect various performance data about the whole system.

       Note: To get this data the collectd user needs the "api-perf-object-
       get-instances" capability.

       Interval Seconds
           Collect disk statistics every Seconds seconds.




4.10.2                      2010-11-27                         34





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       GetCPULoad true|false
           If you set this option to true the current CPU usage will be read.
           This will be the average usage between all CPUs in your NetApp
           without any information about individual CPUs.

           Note: These are the same values that the NetApp CLI command
           "sysstat" returns in the "CPU" field.

           Optional

           Type: boolean

           Default: true

           Result: Two value lists of type "cpu", and type instances "idle"
           and "system".

       GetInterfaces true|false
           If you set this option to true the current traffic of the network
           interfaces will be read. This will be the total traffic over all
           interfaces of your NetApp without any information about individual
           interfaces.

           Note: This is the same values that the NetApp CLI command "sysstat"
           returns in the "Net kB/s" field.

           Or is it?

           Optional

           Type: boolean

           Default: true

           Result: One value list of type "if_octects".

       GetDiskIO true|false
           If you set this option to true the current IO throughput will be
           read. This will be the total IO of your NetApp without any
           information about individual disks, volumes or aggregates.

           Note: This is the same values that the NetApp CLI command "sysstat"
           returns in the "Disk kB/s" field.

           Optional

           Type: boolean

           Default: true

           Result: One value list of type "disk_octets".

       GetDiskOps true|false
           If you set this option to true the current number of HTTP, NFS,



4.10.2                      2010-11-27                         35





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


           CIFS, FCP, iSCSI, etc. operations will be read. This will be the
           total number of operations on your NetApp without any information
           about individual volumes or aggregates.

           Note: These are the same values that the NetApp CLI command
           "sysstat" returns in the "NFS", "CIFS", "HTTP", "FCP" and "iSCSI"
           fields.

           Optional

           Type: boolean

           Default: true

           Result: A variable number of value lists of type
           "disk_ops_complex". Each type of operation will result in one value
           list with the name of the operation as type instance.

       The WAFL block

       This will collect various performance data about the WAFL file system.
       At the moment this just means cache performance.

       Note: To get this data the collectd user needs the "api-perf-object-
       get-instances" capability.

       Note: The interface to get these values is classified as "Diagnostics"
       by NetApp. This means that it is not guaranteed to be stable even
       between minor releases.

       Interval Seconds
           Collect disk statistics every Seconds seconds.

       GetNameCache true|false
           Optional

           Type: boolean

           Default: true

           Result: One value list of type "cache_ratio" and type instance
           "name_cache_hit".

       GetDirCache true|false
           Optional

           Type: boolean

           Default: true

           Result: One value list of type "cache_ratio" and type instance
           "find_dir_hit".





4.10.2                      2010-11-27                         36





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       GetInodeCache true|false
           Optional

           Type: boolean

           Default: true

           Result: One value list of type "cache_ratio" and type instance
           "inode_cache_hit".

       GetBufferCache true|false
           Note: This is the same value that the NetApp CLI command "sysstat"
           returns in the "Cache hit" field.

           Optional

           Type: boolean

           Default: true

           Result: One value list of type "cache_ratio" and type instance
           "buf_hash_hit".

       The Disks block

       This will collect performance data about the individual disks in the
       NetApp.

       Note: To get this data the collectd user needs the "api-perf-object-
       get-instances" capability.

       Interval Seconds
           Collect disk statistics every Seconds seconds.

       GetBusy true|false
           If you set this option to true the busy time of all disks will be
           calculated and the value of the busiest disk in the system will be
           written.

           Note: This is the same values that the NetApp CLI command "sysstat"
           returns in the "Disk util" field. Probably.

           Optional

           Type: boolean

           Default: true

           Result: One value list of type "percent" and type instance
           "disk_busy".

       The VolumePerf block

       This will collect various performance data about the individual



4.10.2                      2010-11-27                         37





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       volumes.

       You can select which data to collect about which volume using the
       following options. They follow the standard ignorelist semantic.

       Note: To get this data the collectd user needs the api-perf-object-get-
       instances capability.

       Interval Seconds
           Collect volume performance data every Seconds seconds.

       GetIO Volume
       GetOps Volume
       GetLatency Volume
           Select the given volume for IO, operations or latency statistics
           collection.  The argument is the name of the volume without the
           "/vol/" prefix.

           Since the standard ignorelist functionality is used here, you can
           use a string starting and ending with a slash to specify regular
           expression matching: To match the volumes "vol0", "vol2" and
           "vol7", you can use this regular expression:

             GetIO "/^vol[027]$/"

           If no regular expression is specified, an exact match is required.
           Both, regular and exact matching are case sensitive.

           If no volume was specified at all for either of the three options,
           that data will be collected for all available volumes.

       IgnoreSelectedIO true|false
       IgnoreSelectedOps true|false
       IgnoreSelectedLatency true|false
           When set to true, the volumes selected for IO, operations or
           latency statistics collection will be ignored and the data will be
           collected for all other volumes.

           When set to false, data will only be collected for the specified
           volumes and all other volumes will be ignored.

           If no volumes have been specified with the above Get* options, all
           volumes will be collected regardless of the IgnoreSelected* option.

           Defaults to false

       The VolumeUsage block

       This will collect capacity data about the individual volumes.

       Note: To get this data the collectd user needs the api-volume-list-info
       capability.





4.10.2                      2010-11-27                         38





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       Interval Seconds
           Collect volume usage statistics every Seconds seconds.

       GetCapacity VolumeName
           The current capacity of the volume will be collected. This will
           result in two to four value lists, depending on the configuration
           of the volume. All data sources are of type "df_complex" with the
           name of the volume as plugin_instance.

           There will be type_instances "used" and "free" for the number of
           used and available bytes on the volume.  If the volume has some
           space reserved for snapshots, a type_instance "snap_reserved" will
           be available.  If the volume has SIS enabled, a type_instance
           "sis_saved" will be available. This is the number of bytes saved by
           the SIS feature.

           Note: The current NetApp API has a bug that results in this value
           being reported as a 32 bit number. This plugin tries to guess the
           correct number which works most of the time.  If you see strange
           values here, bug NetApp support to fix this.

           Repeat this option to specify multiple volumes.

       IgnoreSelectedCapacity true|false
           Specify whether to collect only the volumes selected by the
           GetCapacity option or to ignore those volumes.
           IgnoreSelectedCapacity defaults to false. However, if no
           GetCapacity option is specified at all, all capacities will be
           selected anyway.

       GetSnapshot VolumeName
           Select volumes from which to collect snapshot information.

           Usually, the space used for snapshots is included in the space
           reported as "used". If snapshot information is collected as well,
           the space used for snapshots is subtracted from the used space.

           To make things even more interesting, it is possible to reserve
           space to be used for snapshots. If the space required for snapshots
           is less than that reserved space, there is "reserved free" and
           "reserved used" space in addition to "free" and "used". If the
           space required for snapshots exceeds the reserved space, that part
           allocated in the normal space is subtracted from the "used" space
           again.

           Repeat this option to specify multiple volumes.

       IgnoreSelectedSnapshot
           Specify whether to collect only the volumes selected by the
           GetSnapshot option or to ignore those volumes.
           IgnoreSelectedSnapshot defaults to false. However, if no
           GetSnapshot option is specified at all, all capacities will be
           selected anyway.




4.10.2                      2010-11-27                         39





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


   Plugin "netlink"
       The "netlink" plugin uses a netlink socket to query the Linux kernel
       about statistics of various interface and routing aspects.

       Interface Interface
       VerboseInterface Interface
           Instruct the plugin to collect interface statistics. This is
           basically the same as the statistics provided by the "interface"
           plugin (see above) but potentially much more detailed.

           When configuring with Interface only the basic statistics will be
           collected, namely octets, packets, and errors. These statistics are
           collected by the "interface" plugin, too, so using both at the same
           time is no benefit.

           When configured with VerboseInterface all counters except the basic
           ones, so that no data needs to be collected twice if you use the
           "interface" plugin.  This includes dropped packets, received
           multicast packets, collisions and a whole zoo of differentiated RX
           and TX errors. You can try the following command to get an idea of
           what awaits you:

             ip -s -s link list

           If Interface is All, all interfaces will be selected.

       QDisc Interface [QDisc]
       Class Interface [Class]
       Filter Interface [Filter]
           Collect the octets and packets that pass a certain qdisc, class or
           filter.

           QDiscs and classes are identified by their type and handle (or
           classid).  Filters don't necessarily have a handle, therefore the
           parent's handle is used.  The notation used in collectd differs
           from that used in tc(1) in that it doesn't skip the major or minor
           number if it's zero and doesn't print special ids by their name.
           So, for example, a qdisc may be identified by "pfifo_fast-1:0" even
           though the minor number of all qdiscs is zero and thus not
           displayed by tc(1).

           If QDisc, Class, or Filter is given without the second argument,
           i. .e. without an identifier, all qdiscs, classes, or filters that
           are associated with that interface will be collected.

           Since a filter itself doesn't necessarily have a handle, the
           parent's handle is used. This may lead to problems when more than
           one filter is attached to a qdisc or class. This isn't nice, but we
           don't know how this could be done any better. If you have a idea,
           please don't hesitate to tell us.

           As with the Interface option you can specify All as the interface,
           meaning all interfaces.




4.10.2                      2010-11-27                         40





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


           Here are some examples to help you understand the above text more
           easily:

             <Plugin netlink>
               VerboseInterface "All"
               QDisc "eth0" "pfifo_fast-1:0"
               QDisc "ppp0"
               Class "ppp0" "htb-1:10"
               Filter "ppp0" "u32-1:0"
             </Plugin>

       IgnoreSelected
           The behavior is the same as with all other similar plugins: If
           nothing is selected at all, everything is collected. If some things
           are selected using the options described above, only these
           statistics are collected. If you set IgnoreSelected to true, this
           behavior is inverted, i. e. the specified statistics will not be
           collected.

   Plugin "network"
       The Network plugin sends data to a remote instance of collectd,
       receives data from a remote instance, or both at the same time. Data
       which has been received from the network is usually not transmitted
       again, but this can be activated, see the Forward option below.

       The default IPv6 multicast group is "ff18::efc0:4a42". The default IPv4
       multicast group is 239.192.74.66. The default UDP port is 25826.

       Both, Server and Listen can be used as single option or as block. When
       used as block, given options are valid for this socket only. For
       example:

        <Plugin "network">
          Server "collectd.internal.tld"
          <Server "collectd.external.tld">
            SecurityLevel "sign"
            Username "myhostname"
            Password "ohl0eQue"
          </Server>
        </Plugin>

       <Server Host [Port]>
           The Server statement/block sets the server to send datagrams to.
           The statement may occur multiple times to send each datagram to
           multiple destinations.

           The argument Host may be a hostname, an IPv4 address or an IPv6
           address. The optional second argument specifies a port number or a
           service name. If not given, the default, 25826, is used.

           The following options are recognized within Server blocks:

           SecurityLevel Encrypt|Sign|None
               Set the security you require for network communication. When



4.10.2                      2010-11-27                         41





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


               the security level has been set to Encrypt, data sent over the
               network will be encrypted using AES-256. The integrity of
               encrypted packets is ensured using SHA-1. When set to Sign,
               transmitted data is signed using the HMAC-SHA-256 message
               authentication code. When set to None, data is sent without any
               security.

               This feature is only available if the network plugin was linked
               with libgcrypt.

           Username Username
               Sets the username to transmit. This is used by the server to
               lookup the password. See AuthFile below. All security levels
               except None require this setting.

               This feature is only available if the network plugin was linked
               with libgcrypt.

           Password Password
               Sets a password (shared secret) for this socket. All security
               levels except None require this setting.

               This feature is only available if the network plugin was linked
               with libgcrypt.

           Interface Interface name
               Set the outgoing interface for IP packets. This applies at
               least to IPv6 packets and if possible to IPv4. If this option
               is not applicable, undefined or a non-existent interface name
               is specified, the default behavior is to let the kernel choose
               the appropriate interface. Be warned that the manual selection
               of an interface for unicast traffic is only necessary in rare
               cases.

       <Listen Host [Port]>
           The Listen statement sets the interfaces to bind to. When multiple
           statements are found the daemon will bind to multiple interfaces.

           The argument Host may be a hostname, an IPv4 address or an IPv6
           address. If the argument is a multicast address the daemon will
           join that multicast group.  The optional second argument specifies
           a port number or a service name. If not given, the default, 25826,
           is used.

           The following options are recognized within "<Listen>" blocks:

           SecurityLevel Encrypt|Sign|None
               Set the security you require for network communication. When
               the security level has been set to Encrypt, only encrypted data
               will be accepted. The integrity of encrypted packets is ensured
               using SHA-1. When set to Sign, only signed and encrypted data
               is accepted. When set to None, all data will be accepted. If an
               AuthFile option was given (see below), encrypted data is
               decrypted if possible.



4.10.2                      2010-11-27                         42





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


               This feature is only available if the network plugin was linked
               with libgcrypt.

           AuthFile Filename
               Sets a file in which usernames are mapped to passwords. These
               passwords are used to verify signatures and to decrypt
               encrypted network packets. If SecurityLevel is set to None,
               this is optional. If given, signed data is verified and
               encrypted packets are decrypted. Otherwise, signed data is
               accepted without checking the signature and encrypted data
               cannot be decrypted.  For the other security levels this option
               is mandatory.

               The file format is very simple: Each line consists of a
               username followed by a colon and any number of spaces followed
               by the password. To demonstrate, an example file could look
               like this:

                 user0: foo
                 user1: bar

               Each time a packet is received, the modification time of the
               file is checked using stat(2). If the file has been changed,
               the contents is re-read. While the file is being read, it is
               locked using fcntl(2).

           Interface Interface name
               Set the incoming interface for IP packets explicitly. This
               applies at least to IPv6 packets and if possible to IPv4. If
               this option is not applicable, undefined or a non-existent
               interface name is specified, the default behavior is, to let
               the kernel choose the appropriate interface. Thus incoming
               traffic gets only accepted, if it arrives on the given
               interface.

       TimeToLive 1-255
           Set the time-to-live of sent packets. This applies to all, unicast
           and multicast, and IPv4 and IPv6 packets. The default is to not
           change this value.  That means that multicast packets will be sent
           with a TTL of 1 (one) on most operating systems.

       MaxPacketSize 1024-65535
           Set the maximum size for datagrams received over the network.
           Packets larger than this will be truncated.

       Forward true|false
           If set to true, write packets that were received via the network
           plugin to the sending sockets. This should only be activated when
           the Listen- and Server-statements differ. Otherwise packets may be
           send multiple times to the same multicast group. While this results
           in more network traffic than necessary it's not a huge problem
           since the plugin has a duplicate detection, so the values will not
           loop.




4.10.2                      2010-11-27                         43





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       CacheFlush Seconds
           For each host/plugin/type combination the "network plugin" caches
           the time of the last value being sent or received. Every Seconds
           seconds the plugin searches and removes all entries that are older
           than Seconds seconds, thus freeing the unused memory again. Since
           this process is somewhat expensive and normally doesn't do much,
           this value should not be too small. The default is 1800 seconds,
           but setting this to 86400 seconds (one day) will not do much harm
           either.

       ReportStats true|false
           The network plugin cannot only receive and send statistics, it can
           also create statistics about itself. Collected data included the
           number of received and sent octets and packets, the length of the
           receive queue and the number of values handled. When set to true,
           the Network plugin will make these statistics available. Defaults
           to false.

   Plugin "nginx"
       This plugin collects the number of connections and requests handled by
       the "nginx daemon" (speak: engine X), a HTTP and mail server/proxy. It
       queries the page provided by the "ngx_http_stub_status_module" module,
       which isn't compiled by default. Please refer to
       <http://wiki.codemongers.com/NginxStubStatusModule> for more
       information on how to compile and configure nginx and this module.

       The following options are accepted by the "nginx plugin":

       URL http://host/nginx_status
           Sets the URL of the "ngx_http_stub_status_module" output.

       User Username
           Optional user name needed for authentication.

       Password Password
           Optional password needed for authentication.

       VerifyPeer true|false
           Enable or disable peer SSL certificate verification. See
           <http://curl.haxx.se/docs/sslcerts.html> for details. Enabled by
           default.

       VerifyHost true|false
           Enable or disable peer host name verification. If enabled, the
           plugin checks if the "Common Name" or a "Subject Alternate Name"
           field of the SSL certificate matches the host name provided by the
           URL option. If this identity check fails, the connection is
           aborted. Obviously, only works when connecting to a SSL enabled
           server. Enabled by default.

       CACert File
           File that holds one or more SSL certificates. If you want to use
           HTTPS you will possibly need this option. What CA certificates come
           bundled with "libcurl" and are checked by default depends on the



4.10.2                      2010-11-27                         44





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


           distribution you use.

   Plugin "notify_desktop"
       This plugin sends a desktop notification to a notification daemon, as
       defined in the Desktop Notification Specification. To actually display
       the notifications, notification-daemon is required and collectd has to
       be able to access the X server.

       The Desktop Notification Specification can be found at
       <http://www.galago-project.org/specs/notification/>.

       OkayTimeout timeout
       WarningTimeout timeout
       FailureTimeout timeout
           Set the timeout, in milliseconds, after which to expire the
           notification for "OKAY", "WARNING" and "FAILURE" severities
           respectively. If zero has been specified, the displayed
           notification will not be closed at all - the user has to do so
           herself. These options default to 5000. If a negative number has
           been specified, the default is used as well.

   Plugin "notify_email"
       The notify_email plugin uses the ESMTP library to send notifications to
       a configured email address.

       libESMTP is available from <http://www.stafford.uklinux.net/libesmtp/>.

       Available configuration options:

       From Address
           Email address from which the emails should appear to come from.

           Default: "root@localhost"

       Recipient Address
           Configures the email address(es) to which the notifications should
           be mailed.  May be repeated to send notifications to multiple
           addresses.

           At least one Recipient must be present for the plugin to work
           correctly.

       SMTPServer Hostname
           Hostname of the SMTP server to connect to.

           Default: "localhost"

       SMTPPort Port
           TCP port to connect to.

           Default: 25

       SMTPUser Username
           Username for ASMTP authentication. Optional.



4.10.2                      2010-11-27                         45





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       SMTPPassword Password
           Password for ASMTP authentication. Optional.

       Subject Subject
           Subject-template to use when sending emails. There must be exactly
           two string-placeholders in the subject, given in the standard
           printf(3) syntax, i. e. %s. The first will be replaced with the
           severity, the second with the hostname.

           Default: "Collectd notify: %s@%s"

   Plugin "ntpd"
       Host Hostname
           Hostname of the host running ntpd. Defaults to localhost.

       Port Port
           UDP-Port to connect to. Defaults to 123.

       ReverseLookups true|false
           Sets whether or not to perform reverse lookups on peers. Since the
           name or IP-address may be used in a filename it is recommended to
           disable reverse lookups. The default is to do reverse lookups to
           preserve backwards compatibility, though.

   Plugin "nut"
       UPS upsname@hostname[:port]
           Add a UPS to collect data from. The format is identical to the one
           accepted by upsc(8).

   Plugin "olsrd"
       The olsrd plugin connects to the TCP port opened by the txtinfo plugin
       of the Optimized Link State Routing daemon and reads information about
       the current state of the meshed network.

       The following configuration options are understood:

       Host Host
           Connect to Host. Defaults to "localhost".

       Port Port
           Specifies the port to connect to. This must be a string, even if
           you give the port as a number rather than a service name. Defaults
           to "2006".

       CollectLinks No|Summary|Detail
           Specifies what information to collect about links, i. e. direct
           connections of the daemon queried. If set to No, no information is
           collected. If set to Summary, the number of links and the average
           of all link quality (LQ) and neighbor link quality (NLQ) values is
           calculated.  If set to Detail LQ and NLQ are collected per link.

           Defaults to Detail.





4.10.2                      2010-11-27                         46





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       CollectRoutes No|Summary|Detail
           Specifies what information to collect about routes of the daemon
           queried. If set to No, no information is collected. If set to
           Summary, the number of routes and the average metric and ETX is
           calculated. If set to Detail metric and ETX are collected per
           route.

           Defaults to Summary.

       CollectTopology No|Summary|Detail
           Specifies what information to collect about the global topology. If
           set to No, no information is collected. If set to Summary, the
           number of links in the entire topology and the average link quality
           (LQ) is calculated.  If set to Detail LQ and NLQ are collected for
           each link in the entire topology.

           Defaults to Summary.

   Plugin "onewire"
       EXPERIMENTAL! See notes below.

       The "onewire" plugin uses the owcapi library from the owfs project
       <http://owfs.org/> to read sensors connected via the onewire bus.

       Currently only temperature sensors (sensors with the family code 10,
       e. g. DS1820, DS18S20, DS1920) can be read. If you have other sensors
       you would like to have included, please send a sort request to the
       mailing list.

       Hubs (the DS2409 chips) are working, but read the note, why this plugin
       is experimental, below.

       Device Device
           Sets the device to read the values from. This can either be a
           "real" hardware device, such as a serial port or an USB port, or
           the address of the owserver(1) socket, usually localhost:4304.

           Though the documentation claims to automatically recognize the
           given address format, with version 2.7p4 we had to specify the type
           explicitly. So with that version, the following configuration
           worked for us:

             <Plugin onewire>
               Device "-s localhost:4304"
             </Plugin>

           This directive is required and does not have a default value.

       Sensor Sensor
           Selects sensors to collect or to ignore, depending on
           IgnoreSelected, see below. Sensors are specified without the family
           byte at the beginning, to you'd use "F10FCA000800", and not include
           the leading 10. family byte and point.




4.10.2                      2010-11-27                         47





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       IgnoreSelected true|false
           If no configuration if given, the onewire plugin will collect data
           from all sensors found. This may not be practical, especially if
           sensors are added and removed regularly. Sometimes, however, it's
           easier/preferred to collect only specific sensors or all sensors
           except a few specified ones. This option enables you to do that: By
           setting IgnoreSelected to true the effect of Sensor is inverted:
           All selected interfaces are ignored and all other interfaces are
           collected.

       Interval Seconds
           Sets the interval in which all sensors should be read. If not
           specified, the global Interval setting is used.

       EXPERIMENTAL! The "onewire" plugin is experimental, because it doesn't
       yet work with big setups. It works with one sensor being attached to
       one controller, but as soon as you throw in a couple more senors and
       maybe a hub or two, reading all values will take more than ten seconds
       (the default interval). We will probably add some separate thread for
       reading the sensors and some cache or something like that, but it's not
       done yet. We will try to maintain backwards compatibility in the
       future, but we can't promise. So in short: If it works for you: Great!
       But keep in mind that the config might change, though this is unlikely.
       Oh, and if you want to help improving this plugin, just send a short
       notice to the mailing list. Thanks :)

   Plugin "openvpn"
       The OpenVPN plugin reads a status file maintained by OpenVPN and
       gathers traffic statistics about connected clients.

       To set up OpenVPN to write to the status file periodically, use the
       --status option of OpenVPN. Since OpenVPN can write two different
       formats, you need to set the required format, too. This is done by
       setting --status-version to 2.

       So, in a nutshell you need:

         openvpn $OTHER_OPTIONS \
           --status "/var/run/openvpn-status" 10 \
           --status-version 2

       Available options:

       StatusFile File
           Specifies the location of the status file.

       ImprovedNamingSchema true|false
           When enabled, the filename of the status file will be used as
           plugin instance and the client's "common name" will be used as type
           instance. This is required when reading multiple status files.
           Enabling this option is recommended, but to maintain backwards
           compatibility this option is disabled by default.





4.10.2                      2010-11-27                         48





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       CollectCompression true|false
           Sets whether or not statistics about the compression used by
           OpenVPN should be collected. This information is only available in
           single mode. Enabled by default.

       CollectIndividualUsers true|false
           Sets whether or not traffic information is collected for each
           connected client individually. If set to false, currently no
           traffic data is collected at all because aggregating this data in a
           save manner is tricky. Defaults to true.

       CollectUserCount true|false
           When enabled, the number of currently connected clients or users is
           collected.  This is especially interesting when
           CollectIndividualUsers is disabled, but can be configured
           independently from that option. Defaults to false.

   Plugin "oracle"
       The "oracle" plugin uses the OracleAX Call Interface (OCI) to connect
       to an OracleAX Database and lets you execute SQL statements there. It
       is very similar to the "dbi" plugin, because it was written around the
       same time. See the "dbi" plugin's documentation above for details.

         <Plugin oracle>
           <Query "out_of_stock">
             Statement "SELECT category, COUNT(*) AS value FROM products WHERE in_stock = 0 GROUP BY category"
             <Result>
               Type "gauge"
               # InstancePrefix "foo"
               InstancesFrom "category"
               ValuesFrom "value"
             </Result>
           </Query>
           <Database "product_information">
             ConnectID "db01"
             Username "oracle"
             Password "secret"
             Query "out_of_stock"
           </Database>
         </Plugin>

       Query blocks

       The Query blocks are handled identically to the Query blocks of the
       "dbi" plugin. Please see its documentation above for details on how to
       specify queries.

       Database blocks

       Database blocks define a connection to a database and which queries
       should be sent to that database. Each database needs a "name" as string
       argument in the starting tag of the block. This name will be used as
       "PluginInstance" in the values submitted to the daemon. Other than
       that, that name is not used.



4.10.2                      2010-11-27                         49





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       ConnectID ID
           Defines the "database alias" or "service name" to connect to.
           Usually, these names are defined in the file named
           "$ORACLE_HOME/network/admin/tnsnames.ora".

       Username Username
           Username used for authentication.

       Password Password
           Password used for authentication.

       Query QueryName
           Associates the query named QueryName with this database connection.
           The query needs to be defined before this statement, i. e. all
           query blocks you want to refer to must be placed above the database
           block you want to refer to them from.

   Plugin "perl"
       This plugin embeds a Perl-interpreter into collectd and provides an
       interface to collectd's plugin system. See collectd-perl(5) for its
       documentation.

   Plugin "pinba"
       The Pinba plugin receives profiling information from Pinba, an
       extension for the PHP interpreter. At the end of executing a script,
       i.e. after a PHP-based webpage has been delivered, the extension will
       send a UDP packet containing timing information, peak memory usage and
       so on. The plugin will wait for such packets, parse them and account
       the provided information, which is then dispatched to the daemon once
       per interval.

       Synopsis:

        <Plugin pinba>
          Address "::0"
          Port "30002"
          # Overall statistics for the website.
          <View "www-total">
            Server "www.example.com"
          </View>
          # Statistics for www-a only
          <View "www-a">
            Host "www-a.example.com"
            Server "www.example.com"
          </View>
          # Statistics for www-b only
          <View "www-b">
            Host "www-b.example.com"
            Server "www.example.com"
          </View>
        </Plugin>

       The plugin provides the following configuration options:




4.10.2                      2010-11-27                         50





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       Address Node
           Configures the address used to open a listening socket. By default,
           plugin will bind to the any address "::0".

       Port Service
           Configures the port (service) to bind to. By default the default
           Pinba port "30002" will be used. The option accepts service names
           in addition to port numbers and thus requires a string argument.

       <View Name> block
           The packets sent by the Pinba extension include the hostname of the
           server, the server name (the name of the virtual host) and the
           script that was executed.  Using View blocks it is possible to
           separate the data into multiple groups to get more meaningful
           statistics. Each packet is added to all matching groups, so that a
           packet may be accounted for more than once.

           Host Host
               Matches the hostname of the system the webserver / script is
               running on. This will contain the result of the gethostname(2)
               system call. If not configured, all hostnames will be accepted.

           Server Server
               Matches the name of the virtual host, i.e. the contents of the
               $_SERVER["SERVER_NAME"] variable when within PHP. If not
               configured, all server names will be accepted.

           Script Script
               Matches the name of the script name, i.e. the contents of the
               $_SERVER["SCRIPT_NAME"] variable when within PHP. If not
               configured, all script names will be accepted.

   Plugin "ping"
       The Ping plugin starts a new thread which sends ICMP "ping" packets to
       the configured hosts periodically and measures the network latency.
       Whenever the "read" function of the plugin is called, it submits the
       average latency, the standard deviation and the drop rate for each
       host.

       Available configuration options:

       Host IP-address
           Host to ping periodically. This option may be repeated several
           times to ping multiple hosts.

       Interval Seconds
           Sets the interval in which to send ICMP echo packets to the
           configured hosts.  This is not the interval in which statistics are
           queries from the plugin but the interval in which the hosts are
           "pinged". Therefore, the setting here should be smaller than or
           equal to the global Interval setting. Fractional times, such as
           "1.24" are allowed.

           Default: 1.0



4.10.2                      2010-11-27                         51





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       Timeout Seconds
           Time to wait for a response from the host to which an ICMP packet
           had been sent. If a reply was not received after Seconds seconds,
           the host is assumed to be down or the packet to be dropped. This
           setting must be smaller than the Interval setting above for the
           plugin to work correctly. Fractional arguments are accepted.

           Default: 0.9

       TTL 0-255
           Sets the Time-To-Live of generated ICMP packets.

       SourceAddress host
           Sets the source address to use. host may either be a numerical
           network address or a network hostname.

       Device name
           Sets the outgoing network device to be used. name has to specify an
           interface name (e. g. "eth0"). This might not be supported by all
           operating systems.

       MaxMissed Packets
           Trigger a DNS resolve after the host has not replied to Packets
           packets. This enables the use of dynamic DNS services (like
           dyndns.org) with the ping plugin.

           Default: -1 (disabled)

   Plugin "postgresql"
       The "postgresql" plugin queries statistics from PostgreSQL databases.
       It keeps a persistent connection to all configured databases and tries
       to reconnect if the connection has been interrupted. A database is
       configured by specifying a Database block as described below. The
       default statistics are collected from PostgreSQL's statistics collector
       which thus has to be enabled for this plugin to work correctly. This
       should usually be the case by default. See the section "The Statistics
       Collector" of the PostgreSQL Documentation for details.

       By specifying custom database queries using a Query block as described
       below, you may collect any data that is available from some PostgreSQL
       database. This way, you are able to access statistics of external
       daemons which are available in a PostgreSQL database or use future or
       special statistics provided by PostgreSQL without the need to upgrade
       your collectd installation.

       The PostgreSQL Documentation manual can be found at
       <http://www.postgresql.org/docs/manuals/>.










4.10.2                      2010-11-27                         52





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


         <Plugin postgresql>
           <Query magic>
             Statement "SELECT magic FROM wizard WHERE host = $1;"
             Param hostname
             <Result>
               Type gauge
               InstancePrefix "magic"
               ValuesFrom magic
             </Result>
           </Query>

           <Query rt36_tickets>
             Statement "SELECT COUNT(type) AS count, type \
                               FROM (SELECT CASE \
                                            WHEN resolved = 'epoch' THEN 'open' \
                                            ELSE 'resolved' END AS type \
                                            FROM tickets) type \
                               GROUP BY type;"
             <Result>
               Type counter
               InstancePrefix "rt36_tickets"
               InstancesFrom "type"
               ValuesFrom "count"
             </Result>
           </Query>

           <Database foo>
             Host "hostname"
             Port "5432"
             User "username"
             Password "secret"
             SSLMode "prefer"
             KRBSrvName "kerberos_service_name"
             Query magic
           </Database>

           <Database bar>
             Interval 300
             Service "service_name"
             Query backend # predefined
             Query rt36_tickets
           </Database>
         </Plugin>

       The Query block defines one database query which may later be used by a
       database definition. It accepts a single mandatory argument which
       specifies the name of the query. The names of all queries have to be
       unique (see the MinVersion and MaxVersion options below for an
       exception to this rule). The following configuration options are
       available to define the query:

       In each Query block, there is one or more Result blocks. Result blocks
       define how to handle the values returned from the query. They define
       which column holds which value and how to dispatch that value to the



4.10.2                      2010-11-27                         53





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       daemon.  Multiple Result blocks may be used to extract multiple values
       from a single query.

       Statement sql query statement
           Specify the sql query statement which the plugin should execute.
           The string may contain the tokens $1, $2, etc. which are used to
           reference the first, second, etc. parameter. The value of the
           parameters is specified by the Param configuration option - see
           below for details. To include a literal $ character followed by a
           number, surround it with single quotes (').

           Any SQL command which may return data (such as "SELECT" or "SHOW")
           is allowed. Note, however, that only a single command may be used.
           Semicolons are allowed as long as a single non-empty command has
           been specified only.

           The returned lines will be handled separately one after another.

       Query sql query statement
           This is a deprecated synonym for Statement. It will be removed in
           version 5 of collectd.

       Param hostname|database|username|interval
           Specify the parameters which should be passed to the SQL query. The
           parameters are referred to in the SQL query as $1, $2, etc. in the
           same order as they appear in the configuration file. The value of
           the parameter is determined depending on the value of the Param
           option as follows:

           hostname
               The configured hostname of the database connection. If a UNIX
               domain socket is used, the parameter expands to "localhost".

           database
               The name of the database of the current connection.

           username
               The username used to connect to the database.

           interval
               The interval with which this database is queried (as specified
               by the database specific or global Interval options).

           Please note that parameters are only supported by PostgreSQL's
           protocol version 3 and above which was introduced in version 7.4 of
           PostgreSQL.

       Type type
           The type name to be used when dispatching the values. The type
           describes how to handle the data and where to store it. See
           types.db(5) for more details on types and their configuration. The
           number and type of values (as selected by the ValuesFrom option)
           has to match the type of the given name.




4.10.2                      2010-11-27                         54





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


           This option is required inside a Result block.

       InstancePrefix prefix
       InstancesFrom column0 [column1 ...]
           Specify how to create the "TypeInstance" for each data set (i. e.
           line).  InstancePrefix defines a static prefix that will be
           prepended to all type instances. InstancesFrom defines the column
           names whose values will be used to create the type instance.
           Multiple values will be joined together using the hyphen ("-") as
           separation character.

           The plugin itself does not check whether or not all built instances
           are different. It is your responsibility to assure that each is
           unique.

           Both options are optional. If none is specified, the type instance
           will be empty.

       ValuesFrom column0 [column1 ...]
           Names the columns whose content is used as the actual data for the
           data sets that are dispatched to the daemon. How many such columns
           you need is determined by the Type setting as explained above. If
           you specify too many or not enough columns, the plugin will
           complain about that and no data will be submitted to the daemon.

           The actual data type, as seen by PostgreSQL, is not that important
           as long as it represents numbers. The plugin will automatically
           cast the values to the right type if it know how to do that. For
           that, it uses the strtoll(3) and strtod(3) functions, so anything
           supported by those functions is supported by the plugin as well.

           This option is required inside a Result block and may be specified
           multiple times. If multiple ValuesFrom options are specified, the
           columns are read in the given order.

       Column type [type instance]
           This is a deprecated alternative to a Result block. It will be
           removed in version 5 of collectd. It is equivalent to the following
           Result block:

             <Result>
               Type I<type>
               InstancePrefix I<type instance>
               ValuesFrom I<name of the x. column>
             </Result>

           The order of the Column options defines which columns of the query
           result should be used. The first option specifies the data found in
           the first column, the second option that of the second column, and
           so on.

       MinVersion version
       MaxVersion version
           Specify the minimum or maximum version of PostgreSQL that this



4.10.2                      2010-11-27                         55





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


           query should be used with. Some statistics might only be available
           with certain versions of PostgreSQL. This allows you to specify
           multiple queries with the same name but which apply to different
           versions, thus allowing you to use the same configuration in a
           heterogeneous environment.

           The version has to be specified as the concatenation of the major,
           minor and patch-level versions, each represented as two-decimal-
           digit numbers. For example, version 8.2.3 will become 80203.

       MinPGVersion version
       MaxPGVersion version
           These are deprecated synonyms for MinVersion and MaxVersion
           respectively. They will be removed in version 5 of collectd.

       The following predefined queries are available (the definitions can be
       found in the postgresql_default.conf file which, by default, is
       available at "prefix/share/collectd/"):

       backends
           This query collects the number of backends, i. e. the number of
           connected clients.

       transactions
           This query collects the numbers of committed and rolled-back
           transactions of the user tables.

       queries
           This query collects the numbers of various table modifications
           (i. e.  insertions, updates, deletions) of the user tables.

       query_plans
           This query collects the numbers of various table scans and returned
           tuples of the user tables.

       table_states
           This query collects the numbers of live and dead rows in the user
           tables.

       disk_io
           This query collects disk block access counts for user tables.

       disk_usage
           This query collects the on-disk size of the database in bytes.

       The Database block defines one PostgreSQL database for which to collect
       statistics. It accepts a single mandatory argument which specifies the
       database name. None of the other options are required. PostgreSQL will
       use default values as documented in the section "CONNECTING TO A
       DATABASE" in the psql(1) manpage. However, be aware that those defaults
       may be influenced by the user collectd is run as and special
       environment variables. See the manpage for details.





4.10.2                      2010-11-27                         56





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       Interval seconds
           Specify the interval with which the database should be queried. The
           default is to use the global Interval setting.

       Host hostname
           Specify the hostname or IP of the PostgreSQL server to connect to.
           If the value begins with a slash, it is interpreted as the
           directory name in which to look for the UNIX domain socket.

           This option is also used to determine the hostname that is
           associated with a collected data set. If it has been omitted or
           either begins with with a slash or equals localhost it will be
           replaced with the global hostname definition of collectd. Any other
           value will be passed literally to collectd when dispatching values.
           Also see the global Hostname and FQDNLookup options.

       Port port
           Specify the TCP port or the local UNIX domain socket file extension
           of the server.

       User username
           Specify the username to be used when connecting to the server.

       Password password
           Specify the password to be used when connecting to the server.

       SSLMode disable|allow|prefer|require
           Specify whether to use an SSL connection when contacting the
           server. The following modes are supported:

           disable
               Do not use SSL at all.

           allow
               First, try to connect without using SSL. If that fails, try
               using SSL.

           prefer (default)
               First, try to connect using SSL. If that fails, try without
               using SSL.

           require
               Use SSL only.

       KRBSrvName kerberos_service_name
           Specify the Kerberos service name to use when authenticating with
           Kerberos 5 or GSSAPI. See the sections "Kerberos authentication"
           and "GSSAPI" of the PostgreSQL Documentation for details.

       Service service_name
           Specify the PostgreSQL service name to use for additional
           parameters. That service has to be defined in pg_service.conf and
           holds additional connection parameters. See the section "The
           Connection Service File" in the PostgreSQL Documentation for



4.10.2                      2010-11-27                         57





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


           details.

       Query query
           Specify a query which should be executed for the database
           connection. This may be any of the predefined or user-defined
           queries. If no such option is given, it defaults to "backends",
           "transactions", "queries", "query_plans", "table_states", "disk_io"
           and "disk_usage". Else, the specified queries are used only.

   Plugin "powerdns"
       The "powerdns" plugin queries statistics from an authoritative PowerDNS
       nameserver and/or a PowerDNS recursor. Since both offer a wide variety
       of values, many of which are probably meaningless to most users, but
       may be useful for some. So you may chose which values to collect, but
       if you don't, some reasonable defaults will be collected.

         <Plugin "powerdns">
           <Server "server_name">
             Collect "latency"
             Collect "udp-answers" "udp-queries"
             Socket "/var/run/pdns.controlsocket"
           </Server>
           <Recursor "recursor_name">
             Collect "questions"
             Collect "cache-hits" "cache-misses"
             Socket "/var/run/pdns_recursor.controlsocket"
           </Recursor>
           LocalSocket "/opt/collectd/var/run/collectd-powerdns"
         </Plugin>

       Server and Recursor block
           The Server block defines one authoritative server to query, the
           Recursor does the same for an recursing server. The possible
           options in both blocks are the same, though. The argument defines a
           name for the server / recursor and is required.

           Collect Field
               Using the Collect statement you can select which values to
               collect. Here, you specify the name of the values as used by
               the PowerDNS servers, e. g.  "dlg-only-drops", "answers10-100".

               The method of getting the values differs for Server and
               Recursor blocks: When querying the server a "SHOW *" command is
               issued in any case, because that's the only way of getting
               multiple values out of the server at once.  collectd then picks
               out the values you have selected. When querying the recursor, a
               command is generated to query exactly these values. So if you
               specify invalid fields when querying the recursor, a syntax
               error may be returned by the daemon and collectd may not
               collect any values at all.

               If no Collect statement is given, the following Server values
               will be collected:




4.10.2                      2010-11-27                         58





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


               latency
               packetcache-hit
               packetcache-miss
               packetcache-size
               query-cache-hit
               query-cache-miss
               recursing-answers
               recursing-questions
               tcp-answers
               tcp-queries
               udp-answers
               udp-queries

               The following Recursor values will be collected by default:

               noerror-answers
               nxdomain-answers
               servfail-answers
               sys-msec
               user-msec
               qa-latency
               cache-entries
               cache-hits
               cache-misses
               questions

               Please note that up to that point collectd doesn't know what
               values are available on the server and values that are added do
               not need a change of the mechanism so far. However, the values
               must be mapped to collectd's naming scheme, which is done using
               a lookup table that lists all known values. If values are added
               in the future and collectd does not know about them, you will
               get an error much like this:

                 powerdns plugin: submit: Not found in lookup table: foobar = 42

               In this case please file a bug report with the collectd team.

           Socket Path
               Configures the path to the UNIX domain socket to be used when
               connecting to the daemon. By default
               "${localstatedir}/run/pdns.controlsocket" will be used for an
               authoritative server and
               "${localstatedir}/run/pdns_recursor.controlsocket" will be used
               for the recursor.

       LocalSocket Path
           Querying the recursor is done using UDP. When using UDP over UNIX
           domain sockets, the client socket needs a name in the file system,
           too. You can set this local name to Path using the LocalSocket
           option. The default is "prefix/var/run/collectd-powerdns".

   Plugin "processes"




4.10.2                      2010-11-27                         59





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       Process Name
           Select more detailed statistics of processes matching this name.
           The statistics collected for these selected processes are size of
           the resident segment size (RSS), user- and system-time used, number
           of processes and number of threads, io data (where available) and
           minor and major pagefaults.

       ProcessMatch name regex
           Similar to the Process option this allows to select more detailed
           statistics of processes matching the specified regex (see regex(7)
           for details). The statistics of all matching processes are summed
           up and dispatched to the daemon using the specified name as an
           identifier. This allows to "group" several processes together. name
           must not contain slashes.

   Plugin "protocols"
       Collects a lot of information about various network protocols, such as
       IP, TCP, UDP, etc.

       Available configuration options:

       Value Selector
           Selects whether or not to select a specific value. The string being
           matched is of the form "Protocol:ValueName", where Protocol will be
           used as the plugin instance and ValueName will be used as type
           instance. An example of the string being used would be
           "Tcp:RetransSegs".

           You can use regular expressions to match a large number of values
           with just one configuration option. To select all "extended" TCP
           values, you could use the following statement:

             Value "/^TcpExt:/"

           Whether only matched values are selected or all matched values are
           ignored depends on the IgnoreSelected. By default, only matched
           values are selected.  If no value is configured at all, all values
           will be selected.

       IgnoreSelected true|false
           If set to true, inverts the selection made by Value, i. e. all
           matching values will be ignored.

   Plugin "python"
       This plugin embeds a Python-interpreter into collectd and provides an
       interface to collectd's plugin system. See collectd-python(5) for its
       documentation.

   Plugin "routeros"
       The "routeros" plugin connects to a device running RouterOS, the Linux-
       based operating system for routers by MikroTik. The plugin uses
       librouteros to connect and reads information about the interfaces and
       wireless connections of the device. The configuration supports querying
       multiple routers:



4.10.2                      2010-11-27                         60





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


         <Plugin "routeros">
           <Router>
             Host "router0.example.com"
             User "collectd"
             Password "secr3t"
             CollectInterface true
             CollectCPULoad true
             CollectMemory true
           </Router>
           <Router>
             Host "router1.example.com"
             User "collectd"
             Password "5ecret"
             CollectInterface true
             CollectRegistrationTable true
             CollectDF true
             CollectDisk true
           </Router>
         </Plugin>

       As you can see above, the configuration of the routeros plugin consists
       of one or more <Router> blocks. Within each block, the following
       options are understood:

       Host Host
           Hostname or IP-address of the router to connect to.

       Port Port
           Port name or port number used when connecting. If left unspecified,
           the default will be chosen by librouteros, currently "8728". This
           option expects a string argument, even when a numeric port number
           is given.

       User User
           Use the user name User to authenticate. Defaults to "admin".

       Password Password
           Set the password used to authenticate.

       CollectInterface true|false
           When set to true, interface statistics will be collected for all
           interfaces present on the device. Defaults to false.

       CollectRegistrationTable true|false
           When set to true, information about wireless LAN connections will
           be collected. Defaults to false.

       CollectCPULoad true|false
           When set to true, information about the CPU usage will be
           collected. The number is a dimensionless value where zero indicates
           no CPU usage at all.  Defaults to false.

       CollectMemory true|false
           When enabled, the amount of used and free memory will be collected.



4.10.2                      2010-11-27                         61





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


           How used memory is calculated is unknown, for example whether or
           not caches are counted as used space.  Defaults to false.

       CollectDF true|false
           When enabled, the amount of used and free disk space will be
           collected.  Defaults to false.

       CollectDisk true|false
           When enabled, the number of sectors written and bad blocks will be
           collected.  Defaults to false.

   Plugin "rrdcached"
       The "rrdcached" plugin uses the RRDtool accelerator daemon,
       rrdcached(1), to store values to RRD files in an efficient manner. The
       combination of the "rrdcached" plugin and the "rrdcached" daemon is
       very similar to the way the "rrdtool" plugin works (see below). The
       added abstraction layer provides a number of benefits, though: Because
       the cache is not within "collectd" anymore, it does not need to be
       flushed when "collectd" is to be restarted. This results in much
       shorter (if any) gaps in graphs, especially under heavy load. Also, the
       "rrdtool" command line utility is aware of the daemon so that it can
       flush values to disk automatically when needed. This allows to
       integrate automated flushing of values into graphing solutions much
       more easily.

       There are disadvantages, though: The daemon may reside on a different
       host, so it may not be possible for "collectd" to create the
       appropriate RRD files anymore. And even if "rrdcached" runs on the same
       host, it may run in a different base directory, so relative paths may
       do weird stuff if you're not careful.

       So the recommended configuration is to let "collectd" and "rrdcached"
       run on the same host, communicating via a UNIX domain socket. The
       DataDir setting should be set to an absolute path, so that a changed
       base directory does not result in RRD files being created / expected in
       the wrong place.

       DaemonAddress Address
           Address of the daemon as understood by the "rrdc_connect" function
           of the RRD library. See rrdcached(1) for details. Example:

             <Plugin "rrdcached">
               DaemonAddress "unix:/var/run/rrdcached.sock"
             </Plugin>

       DataDir Directory
           Set the base directory in which the RRD files reside. If this is a
           relative path, it is relative to the working base directory of the
           "rrdcached" daemon!  Use of an absolute path is recommended.

       CreateFiles true|false
           Enables or disables the creation of RRD files. If the daemon is not
           running locally, or DataDir is set to a relative path, this will
           not work as expected. Default is true.



4.10.2                      2010-11-27                         62





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


   Plugin "rrdtool"
       You can use the settings StepSize, HeartBeat, RRARows, and XFF to fine-
       tune your RRD-files. Please read rrdcreate(1) if you encounter problems
       using these settings. If you don't want to dive into the depths of
       RRDtool, you can safely ignore these settings.

       DataDir Directory
           Set the directory to store RRD-files under. Per default RRD-files
           are generated beneath the daemon's working directory, i. e. the
           BaseDir.

       StepSize Seconds
           Force the stepsize of newly created RRD-files. Ideally (and per
           default) this setting is unset and the stepsize is set to the
           interval in which the data is collected. Do not use this option
           unless you absolutely have to for some reason. Setting this option
           may cause problems with the "snmp plugin", the "exec plugin" or
           when the daemon is set up to receive data from other hosts.

       HeartBeat Seconds
           Force the heartbeat of newly created RRD-files. This setting should
           be unset in which case the heartbeat is set to twice the StepSize
           which should equal the interval in which data is collected. Do not
           set this option unless you have a very good reason to do so.

       RRARows NumRows
           The "rrdtool plugin" calculates the number of PDPs per CDP based on
           the StepSize, this setting and a timespan. This plugin creates RRD-
           files with three times five RRAs, i. e. five RRAs with the CFs MIN,
           AVERAGE, and MAX. The five RRAs are optimized for graphs covering
           one hour, one day, one week, one month, and one year.

           So for each timespan, it calculates how many PDPs need to be
           consolidated into one CDP by calculating:
             number of PDPs = timespan / (stepsize * rrarows)

           Bottom line is, set this no smaller than the width of you graphs in
           pixels. The default is 1200.

       RRATimespan Seconds
           Adds an RRA-timespan, given in seconds. Use this option multiple
           times to have more then one RRA. If this option is never used, the
           built-in default of (3600, 86400, 604800, 2678400, 31622400) is
           used.

           For more information on how RRA-sizes are calculated see RRARows
           above.

       XFF Factor
           Set the "XFiles Factor". The default is 0.1. If unsure, don't set
           this option.

       CacheFlush Seconds
           When the "rrdtool" plugin uses a cache (by setting CacheTimeout,



4.10.2                      2010-11-27                         63





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


           see below) it writes all values for a certain RRD-file if the
           oldest value is older than (or equal to) the number of seconds
           specified. If some RRD-file is not updated anymore for some reason
           (the computer was shut down, the network is broken, etc.) some
           values may still be in the cache. If CacheFlush is set, then the
           entire cache is searched for entries older than CacheTimeout
           seconds and written to disk every Seconds seconds. Since this is
           kind of expensive and does nothing under normal circumstances, this
           value should not be too small.  900 seconds might be a good value,
           though setting this to 7200 seconds doesn't normally do much harm
           either.

       CacheTimeout Seconds
           If this option is set to a value greater than zero, the "rrdtool
           plugin" will save values in a cache, as described above. Writing
           multiple values at once reduces IO-operations and thus lessens the
           load produced by updating the files.  The trade off is that the
           graphs kind of "drag behind" and that more memory is used.

       WritesPerSecond Updates
           When collecting many statistics with collectd and the "rrdtool"
           plugin, you will run serious performance problems. The CacheFlush
           setting and the internal update queue assert that collectd
           continues to work just fine even under heavy load, but the system
           may become very unresponsive and slow. This is a problem especially
           if you create graphs from the RRD files on the same machine, for
           example using the "graph.cgi" script included in the
           "contrib/collection3/" directory.

           This setting is designed for very large setups. Setting this option
           to a value between 25 and 80 updates per second, depending on your
           hardware, will leave the server responsive enough to draw graphs
           even while all the cached values are written to disk. Flushed
           values, i. e. values that are forced to disk by the FLUSH command,
           are not effected by this limit. They are still written as fast as
           possible, so that web frontends have up to date data when
           generating graphs.

           For example: If you have 100,000 RRD files and set WritesPerSecond
           to 30 updates per second, writing all values to disk will take
           approximately 56 minutes. Together with the flushing ability that's
           integrated into "collection3" you'll end up with a responsive and
           fast system, up to date graphs and basically a "backup" of your
           values every hour.

       RandomTimeout Seconds
           When set, the actual timeout for each value is chosen randomly
           between CacheTimeout-RandomTimeout and CacheTimeout+RandomTimeout.
           The intention is to avoid high load situations that appear when
           many values timeout at the same time. This is especially a problem
           shortly after the daemon starts, because all values were added to
           the internal cache at roughly the same time.





4.10.2                      2010-11-27                         64





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


   Plugin "sensors"
       The "sensors plugin" uses lm_sensors to retrieve sensor-values. This
       means that all the needed modules have to be loaded and lm_sensors has
       to be configured (most likely by editing /etc/sensors.conf. Read
       sensors.conf(5) for details.

       The lm_sensors homepage can be found at
       <http://secure.netroedge.com/~lm78/>.

       Sensor chip-bus-address/type-feature
           Selects the name of the sensor which you want to collect or ignore,
           depending on the IgnoreSelected below. For example, the option
           "Sensor it8712-isa-0290/voltage-in1" will cause collectd to gather
           data for the voltage sensor in1 of the it8712 on the isa bus at the
           address 0290.

       IgnoreSelected true|false
           If no configuration if given, the sensors-plugin will collect data
           from all sensors. This may not be practical, especially for
           uninteresting sensors.  Thus, you can use the Sensor-option to pick
           the sensors you're interested in. Sometimes, however, it's
           easier/preferred to collect all sensors except a few ones. This
           option enables you to do that: By setting IgnoreSelected to true
           the effect of Sensor is inverted: All selected sensors are ignored
           and all other sensors are collected.

   Plugin "snmp"
       Since the configuration of the "snmp plugin" is a little more
       complicated than other plugins, its documentation has been moved to an
       own manpage, collectd-snmp(5). Please see there for details.

   Plugin "syslog"
       LogLevel debug|info|notice|warning|err
           Sets the log-level. If, for example, set to notice, then all events
           with severity notice, warning, or err will be submitted to the
           syslog-daemon.

           Please note that debug is only available if collectd has been
           compiled with debugging support.

   Plugin "table"
       The "table plugin" provides generic means to parse tabular data and
       dispatch user specified values. Values are selected based on column
       numbers. For example, this plugin may be used to get values from the
       Linux proc(5) filesystem or CSV (comma separated values) files.












4.10.2                      2010-11-27                         65





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


         <Plugin table>
           <Table "/proc/slabinfo">
             Instance "slabinfo"
             Separator " "
             <Result>
               Type gauge
               InstancePrefix "active_objs"
               InstancesFrom 0
               ValuesFrom 1
             </Result>
             <Result>
               Type gauge
               InstancePrefix "objperslab"
               InstancesFrom 0
               ValuesFrom 4
             </Result>
           </Table>
         </Plugin>

       The configuration consists of one or more Table blocks, each of which
       configures one file to parse. Within each Table block, there are one or
       more Result blocks, which configure which data to select and how to
       interpret it.

       The following options are available inside a Table block:

       Instance instance
           If specified, instance is used as the plugin instance. So, in the
           above example, the plugin name "table-slabinfo" would be used. If
           omitted, the filename of the table is used instead, with all
           special characters replaced with an underscore ("_").

       Separator string
           Any character of string is interpreted as a delimiter between the
           different columns of the table. A sequence of two or more
           contiguous delimiters in the table is considered to be a single
           delimiter, i. e. there cannot be any empty columns. The plugin uses
           the strtok_r(3) function to parse the lines of a table - see its
           documentation for more details. This option is mandatory.

           A horizontal tab, newline and carriage return may be specified by
           "\\t", "\\n" and "\\r" respectively. Please note that the double
           backslashes are required because of collectd's config parsing.

       The following options are available inside a Result block:

       Type type
           Sets the type used to dispatch the values to the daemon. Detailed
           information about types and their configuration can be found in
           types.db(5). This option is mandatory.

       InstancePrefix prefix
           If specified, prepend prefix to the type instance. If omitted, only
           the InstancesFrom option is considered for the type instance.



4.10.2                      2010-11-27                         66





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       InstancesFrom column0 [column1 ...]
           If specified, the content of the given columns (identified by the
           column number starting at zero) will be used to create the type
           instance for each row. Multiple values (and the instance prefix)
           will be joined together with dashes (-) as separation character. If
           omitted, only the InstancePrefix option is considered for the type
           instance.

           The plugin itself does not check whether or not all built instances
           are different. ItaXXs your responsibility to assure that each is
           unique. This is especially true, if you do not specify
           InstancesFrom: You have to make sure that the table only contains
           one row.

           If neither InstancePrefix nor InstancesFrom is given, the type
           instance will be empty.

       ValuesFrom column0 [column1 ...]
           Specifies the columns (identified by the column numbers starting at
           zero) whose content is used as the actual data for the data sets
           that are dispatched to the daemon. How many such columns you need
           is determined by the Type setting above. If you specify too many or
           not enough columns, the plugin will complain about that and no data
           will be submitted to the daemon. The plugin uses strtoll(3) and
           strtod(3) to parse counter and gauge values respectively, so
           anything supported by those functions is supported by the plugin as
           well. This option is mandatory.

   Plugin "tail"
       The "tail plugin" follows logfiles, just like tail(1) does, parses each
       line and dispatches found values. What is matched can be configured by
       the user using (extended) regular expressions, as described in
       regex(7).

         <Plugin "tail">
           <File "/var/log/exim4/mainlog">
             Instance "exim"
             <Match>
               Regex "S=([1-9][0-9]*)"
               DSType "CounterAdd"
               Type "ipt_bytes"
               Instance "total"
             </Match>
             <Match>
               Regex "\\<R=local_user\\>"
               ExcludeRegex "\\<R=local_user\\>.*mail_spool defer"
               DSType "CounterInc"
               Type "counter"
               Instance "local_user"
             </Match>
           </File>
         </Plugin>

       The config consists of one or more File blocks, each of which



4.10.2                      2010-11-27                         67





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       configures one logfile to parse. Within each File block, there are one
       or more Match blocks, which configure a regular expression to search
       for.

       The Instance option in the File block may be used to set the plugin
       instance. So in the above example the plugin name "tail-foo" would be
       used.  This plugin instance is for all Match blocks that follow it,
       until the next Instance option. This way you can extract several plugin
       instances from one logfile, handy when parsing syslog and the like.

       Each Match block has the following options to describe how the match
       should be performed:

       Regex regex
           Sets the regular expression to use for matching against a line. The
           first subexpression has to match something that can be turned into
           a number by strtoll(3) or strtod(3), depending on the value of
           "CounterAdd", see below. Because extended regular expressions are
           used, you do not need to use backslashes for subexpressions! If in
           doubt, please consult regex(7). Due to collectd's config parsing
           you need to escape backslashes, though. So if you want to match
           literal parentheses you need to do the following:

             Regex "SPAM \\(Score: (-?[0-9]+\\.[0-9]+)\\)"

       ExcludeRegex regex
           Sets an optional regular expression to use for excluding lines from
           the match.  An example which excludes all connections from
           localhost from the match:

             ExcludeRegex "127\\.0\\.0\\.1"

       DSType Type
           Sets how the values are cumulated. Type is one of:

           GaugeAverage
               Calculate the average.

           GaugeMin
               Use the smallest number only.

           GaugeMax
               Use the greatest number only.

           GaugeLast
               Use the last number found.

           CounterSet
           DeriveSet
           AbsoluteSet
               The matched number is a counter. Simply sets the internal
               counter to this value. Variants exist for "COUNTER", "DERIVE",
               and "ABSOLUTE" data sources.




4.10.2                      2010-11-27                         68





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


           CounterAdd
           DeriveAdd
               Add the matched value to the internal counter. In case of
               DeriveAdd, the matched number may be negative, which will
               effectively subtract from the internal counter.

           CounterInc
           DeriveInc
               Increase the internal counter by one. These DSType are the only
               ones that do not use the matched subexpression, but simply
               count the number of matched lines. Thus, you may use a regular
               expression without submatch in this case.

           As you'd expect the Gauge* types interpret the submatch as a
           floating point number, using strtod(3). The Counter* and
           AbsoluteSet types interpret the submatch as an unsigned integer
           using strtoull(3). The Derive* types interpret the submatch as a
           signed integer using strtoll(3). CounterInc and DeriveInc do not
           use the submatch at all and it may be omitted in this case.

       Type Type
           Sets the type used to dispatch this value. Detailed information
           about types and their configuration can be found in types.db(5).

       Instance TypeInstance
           This optional setting sets the type instance to use.

   Plugin "teamspeak2"
       The "teamspeak2 plugin" connects to the query port of a teamspeak2
       server and polls interesting global and virtual server data. The plugin
       can query only one physical server but unlimited virtual servers. You
       can use the following options to configure it:

       Host hostname/ip
           The hostname or ip which identifies the physical server.  Default:
           127.0.0.1

       Port port
           The query port of the physical server. This needs to be a string.
           Default: "51234"

       Server port
           This option has to be added once for every virtual server the
           plugin should query. If you want to query the virtual server on
           port 8767 this is what the option would look like:

             Server "8767"

           This option, although numeric, needs to be a string, i. e. you must
           use quotes around it! If no such statement is given only global
           information will be collected.

   Plugin "ted"
       The TED plugin connects to a device of "The Energy Detective", a device



4.10.2                      2010-11-27                         69





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       to measure power consumption. These devices are usually connected to a
       serial (RS232) or USB port. The plugin opens a configured device and
       tries to read the current energy readings. For more information on TED,
       visit <http://www.theenergydetective.com/>.

       Available configuration options:

       Device Path
           Path to the device on which TED is connected. collectd will need
           read and write permissions on that file.

           Default: /dev/ttyUSB0

       Retries Num
           Apparently reading from TED is not that reliable. You can therefore
           configure a number of retries here. You only configure the retries
           here, to if you specify zero, one reading will be performed (but no
           retries if that fails); if you specify three, a maximum of four
           readings are performed. Negative values are illegal.

           Default: 0

   Plugin "tcpconns"
       The "tcpconns plugin" counts the number of currently established TCP
       connections based on the local port and/or the remote port. Since there
       may be a lot of connections the default if to count all connections
       with a local port, for which a listening socket is opened. You can use
       the following options to fine-tune the ports you are interested in:

       ListeningPorts true|false
           If this option is set to true, statistics for all local ports for
           which a listening socket exists are collected. The default depends
           on LocalPort and RemotePort (see below): If no port at all is
           specifically selected, the default is to collect listening ports.
           If specific ports (no matter if local or remote ports) are
           selected, this option defaults to false, i. e. only the selected
           ports will be collected unless this option is set to true
           specifically.

       LocalPort Port
           Count the connections to a specific local port. This can be used to
           see how many connections are handled by a specific daemon, e. g.
           the mailserver.  You have to specify the port in numeric form, so
           for the mailserver example you'd need to set 25.

       RemotePort Port
           Count the connections to a specific remote port. This is useful to
           see how much a remote service is used. This is most useful if you
           want to know how many connections a local service has opened to
           remote services, e. g. how many connections a mail server or news
           server has to other mail or news servers, or how many connections a
           web proxy holds to web servers. You have to give the port in
           numeric form.




4.10.2                      2010-11-27                         70





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


   Plugin "thermal"
       ForceUseProcfs true|false
           By default, the "thermal" plugin tries to read the statistics from
           the Linux "sysfs" interface. If that is not available, the plugin
           falls back to the "procfs" interface. By setting this option to
           true, you can force the plugin to use the latter. This option
           defaults to false.

       Device Device
           Selects the name of the thermal device that you want to collect or
           ignore, depending on the value of the IgnoreSelected option. This
           option may be used multiple times to specify a list of devices.

       IgnoreSelected true|false
           Invert the selection: If set to true, all devices except the ones
           that match the device names specified by the Device option are
           collected. By default only selected devices are collected if a
           selection is made. If no selection is configured at all, all
           devices are selected.

   Plugin "tokyotyrant"
       The "tokyotyrant plugin" connects to a TokyoTyrant server and collects
       a couple metrics: number of records, and database size on disk.

       Host Hostname/IP
           The hostname or ip which identifies the server.  Default: 127.0.0.1

       Port Service/Port
           The query port of the server. This needs to be a string, even if
           the port is given in its numeric form.  Default: 1978

   Plugin "unixsock"
       SocketFile Path
           Sets the socket-file which is to be created.

       SocketGroup Group
           If running as root change the group of the UNIX-socket after it has
           been created. Defaults to collectd.

       SocketPerms Permissions
           Change the file permissions of the UNIX-socket after it has been
           created. The permissions must be given as a numeric, octal value as
           you would pass to chmod(1). Defaults to 0770.

   Plugin "uuid"
       This plugin, if loaded, causes the Hostname to be taken from the
       machine's UUID. The UUID is a universally unique designation for the
       machine, usually taken from the machine's BIOS. This is most useful if
       the machine is running in a virtual environment such as Xen, in which
       case the UUID is preserved across shutdowns and migration.

       The following methods are used to find the machine's UUID, in order:

       o   Check /etc/uuid (or UUIDFile).



4.10.2                      2010-11-27                         71





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       o   Check for UUID from HAL
           (<http://www.freedesktop.org/wiki/Software/hal>) if present.

       o   Check for UUID from "dmidecode" / SMBIOS.

       o   Check for UUID from Xen hypervisor.

       If no UUID can be found then the hostname is not modified.

       UUIDFile Path
           Take the UUID from the given file (default /etc/uuid).

   Plugin "vmem"
       The "vmem" plugin collects information about the usage of virtual
       memory.  Since the statistics provided by the Linux kernel are very
       detailed, they are collected very detailed. However, to get all the
       details, you have to switch them on manually. Most people just want an
       overview over, such as the number of pages read from swap space.

       Verbose true|false
           Enables verbose collection of information. This will start
           collecting page "actions", e. g. page allocations, (de)activations,
           steals and so on.  Part of these statistics are collected on a "per
           zone" basis.

   Plugin "vserver"
       This plugin doesn't have any options. VServer support is only available
       for Linux. It cannot yet be found in a vanilla kernel, though. To make
       use of this plugin you need a kernel that has VServer support built in,
       i. e. you need to apply the patches and compile your own kernel, which
       will then provide the /proc/virtual filesystem that is required by this
       plugin.

       The VServer homepage can be found at <http://linux-vserver.org/>.

       Note: The traffic collected by this plugin accounts for the amount of
       traffic passing a socket which might be a lot less than the actual on-
       wire traffic (e. g. due to headers and retransmission). If you want to
       collect on-wire traffic you could, for example, use the logging
       facilities of iptables to feed data for the guest IPs into the iptables
       plugin.

   Plugin "write_http"
       This output plugin submits values to an http server by POST them using
       the PUTVAL plain-text protocol. Each destination you want to post data
       to needs to have one URL block, within which the destination can be
       configured further, for example by specifying authentication data.

       Synopsis:








4.10.2                      2010-11-27                         72





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


        <Plugin "write_http">
          <URL "http://example.com/post-collectd">
            User "collectd"
            Password "weCh3ik0"
          </URL>
        </Plugin>

       URL blocks need one string argument which is used as the URL to which
       data is posted. The following options are understood within URL blocks.

       User Username
           Optional user name needed for authentication.

       Password Password
           Optional password needed for authentication.

       VerifyPeer true|false
           Enable or disable peer SSL certificate verification. See
           <http://curl.haxx.se/docs/sslcerts.html> for details. Enabled by
           default.

       VerifyHost true|false
           Enable or disable peer host name verification. If enabled, the
           plugin checks if the "Common Name" or a "Subject Alternate Name"
           field of the SSL certificate matches the host name provided by the
           URL option. If this identity check fails, the connection is
           aborted. Obviously, only works when connecting to a SSL enabled
           server. Enabled by default.

       CACert File
           File that holds one or more SSL certificates. If you want to use
           HTTPS you will possibly need this option. What CA certificates come
           bundled with "libcurl" and are checked by default depends on the
           distribution you use.

       Format Command|JSON
           Format of the output to generate. If set to Command, will create
           output that is understood by the Exec and UnixSock plugins. When
           set to JSON, will create output in the JavaScript Object Notation
           (JSON).

           Defaults to Command.

       StoreRates true|false
           If set to true, convert counter values to rates. If set to false
           (the default) counter values are stored as is, i. e. as an
           increasing integer number.

THRESHOLD CONFIGURATION
       Starting with version 4.3.0 collectd has support for monitoring. By
       that we mean that the values are not only stored or sent somewhere, but
       that they are judged and, if a problem is recognized, acted upon. The
       only action collectd takes itself is to generate and dispatch a
       "notification". Plugins can register to receive notifications and



4.10.2                      2010-11-27                         73





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       perform appropriate further actions.

       Since systems and what you expect them to do differ a lot, you can
       configure thresholds for your values freely. This gives you a lot of
       flexibility but also a lot of responsibility.

       Every time a value is out of range a notification is dispatched. This
       means that the idle percentage of your CPU needs to be less then the
       configured threshold only once for a notification to be generated.
       There's no such thing as a moving average or similar - at least not
       now.

       Also, all values that match a threshold are considered to be relevant
       or "interesting". As a consequence collectd will issue a notification
       if they are not received for Timeout iterations. The Timeout
       configuration option is explained in section "GLOBAL OPTIONS". If, for
       example, Timeout is set to "2" (the default) and some hosts sends it's
       CPU statistics to the server every 60 seconds, a notification will be
       dispatched after about 120 seconds. It may take a little longer because
       the timeout is checked only once each Interval on the server.

       When a value comes within range again or is received after it was
       missing, an "OKAY-notification" is dispatched.

       Here is a configuration example to get you started. Read below for more
       information.

        <Threshold>
          <Type "foo">
            WarningMin    0.00
            WarningMax 1000.00
            FailureMin    0.00
            FailureMax 1200.00
            Invert false
            Instance "bar"
          </Type>

          <Plugin "interface">
            Instance "eth0"
            <Type "if_octets">
              FailureMax 10000000
              DataSource "rx"
            </Type>
          </Plugin>

          <Host "hostname">
            <Type "cpu">
              Instance "idle"
              FailureMin 10
            </Type>

            <Plugin "memory">
              <Type "memory">
                Instance "cached"



4.10.2                      2010-11-27                         74





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


                WarningMin 100000000
              </Type>
            </Plugin>
          </Host>
        </Threshold>

       There are basically two types of configuration statements: The "Host",
       "Plugin", and "Type" blocks select the value for which a threshold
       should be configured. The "Plugin" and "Type" blocks may be specified
       further using the "Instance" option. You can combine the block by
       nesting the blocks, though they must be nested in the above order,
       i. e. "Host" may contain either "Plugin" and "Type" blocks, "Plugin"
       may only contain "Type" blocks and "Type" may not contain other blocks.
       If multiple blocks apply to the same value the most specific block is
       used.

       The other statements specify the threshold to configure. They must be
       included in a "Type" block. Currently the following statements are
       recognized:

       FailureMax Value
       WarningMax Value
           Sets the upper bound of acceptable values. If unset defaults to
           positive infinity. If a value is greater than FailureMax a FAILURE
           notification will be created. If the value is greater than
           WarningMax but less than (or equal to) FailureMax a WARNING
           notification will be created.

       FailureMin Value
       WarningMin Value
           Sets the lower bound of acceptable values. If unset defaults to
           negative infinity. If a value is less than FailureMin a FAILURE
           notification will be created. If the value is less than WarningMin
           but greater than (or equal to) FailureMin a WARNING notification
           will be created.

       DataSource DSName
           Some data sets have more than one "data source". Interesting
           examples are the "if_octets" data set, which has received ("rx")
           and sent ("tx") bytes and the "disk_ops" data set, which holds
           "read" and "write" operations. The system load data set, "load",
           even has three data sources: "shortterm", "midterm", and
           "longterm".

           Normally, all data sources are checked against a configured
           threshold. If this is undesirable, or if you want to specify
           different limits for each data source, you can use the DataSource
           option to have a threshold apply only to one data source.

       Invert true|false
           If set to true the range of acceptable values is inverted, i. e.
           values between FailureMin and FailureMax (WarningMin and
           WarningMax) are not okay. Defaults to false.




4.10.2                      2010-11-27                         75





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


       Persist true|false
           Sets how often notifications are generated. If set to true one
           notification will be generated for each value that is out of the
           acceptable range. If set to false (the default) then a notification
           is only generated if a value is out of range but the previous value
           was okay.

           This applies to missing values, too: If set to true a notification
           about a missing value is generated once every Interval seconds. If
           set to false only one such notification is generated until the
           value appears again.

       Percentage true|false
           If set to true, the minimum and maximum values given are
           interpreted as percentage value, relative to the other data
           sources. This is helpful for example for the "df" type, where you
           may want to issue a warning when less than 5 % of the total space
           is available. Defaults to false.

FILTER CONFIGURATION
       Starting with collectd 4.6 there is a powerful filtering infrastructure
       implemented in the daemon. The concept has mostly been copied from
       ip_tables, the packet filter infrastructure for Linux. We'll use a
       similar terminology, so that users that are familiar with iptables feel
       right at home.

   Terminology
       The following are the terms used in the remainder of the filter
       configuration documentation. For an ASCII-art schema of the mechanism,
       see "General structure" below.

       Match
           A match is a criteria to select specific values. Examples are, of
           course, the name of the value or it's current value.

           Matches are implemented in plugins which you have to load prior to
           using the match. The name of such plugins starts with the "match_"
           prefix.

       Target
           A target is some action that is to be performed with data. Such
           actions could, for example, be to change part of the value's
           identifier or to ignore the value completely.

           Some of these targets are built into the daemon, see "Built-in
           targets" below. Other targets are implemented in plugins which you
           have to load prior to using the target. The name of such plugins
           starts with the "target_" prefix.

       Rule
           The combination of any number of matches and at least one target is
           called a rule. The target actions will be performed for all values
           for which all matches apply. If the rule does not have any matches
           associated with it, the target action will be performed for all



4.10.2                      2010-11-27                         76





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


           values.

       Chain
           A chain is a list of rules and possibly default targets. The rules
           are tried in order and if one matches, the associated target will
           be called. If a value is handled by a rule, it depends on the
           target whether or not any subsequent rules are considered or if
           traversal of the chain is aborted, see "Flow control" below. After
           all rules have been checked, the default targets will be executed.

   General structure
       The following shows the resulting structure:

        +---------+
        ! Chain   !
        +---------+
             !
             V
        +---------+  +---------+  +---------+  +---------+
        ! Rule    !->! Match   !->! Match   !->! Target  !
        +---------+  +---------+  +---------+  +---------+
             !
             V
        +---------+  +---------+  +---------+
        ! Rule    !->! Target  !->! Target  !
        +---------+  +---------+  +---------+
             !
             V
             :
             :
             !
             V
        +---------+  +---------+  +---------+
        ! Rule    !->! Match   !->! Target  !
        +---------+  +---------+  +---------+
             !
             V
        +---------+
        ! Default !
        ! Target  !
        +---------+

   Flow control
       There are four ways to control which way a value takes through the
       filter mechanism:

       jump
           The built-in jump target can be used to "call" another chain, i. e.
           process the value with another chain. When the called chain
           finishes, usually the next target or rule after the jump is
           executed.

       stop
           The stop condition, signaled for example by the built-in target



4.10.2                      2010-11-27                         77





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


           stop, causes all processing of the value to be stopped immediately.

       return
           Causes processing in the current chain to be aborted, but
           processing of the value generally will continue. This means that if
           the chain was called via Jump, the next target or rule after the
           jump will be executed. If the chain was not called by another
           chain, control will be returned to the daemon and it may pass the
           value to another chain.

       continue
           Most targets will signal the continue condition, meaning that
           processing should continue normally. There is no special built-in
           target for this condition.

   Synopsis
       The configuration reflects this structure directly:

        PostCacheChain "PostCache"
        <Chain "PostCache">
          <Rule "ignore_mysql_show">
            <Match "regex">
              Plugin "^mysql$"
              Type "^mysql_command$"
              TypeInstance "^show_"
            </Match>
            <Target "stop">
            </Target>
          </Rule>
          <Target "write">
            Plugin "rrdtool"
          </Target>
        </Chain>

       The above configuration example will ignore all values where the plugin
       field is "mysql", the type is "mysql_command" and the type instance
       begins with "show_". All other values will be sent to the "rrdtool"
       write plugin via the default target of the chain. Since this chain is
       run after the value has been added to the cache, the MySQL "show_*"
       command statistics will be available via the "unixsock" plugin.

   List of configuration options
       PreCacheChain ChainName
       PostCacheChain ChainName
           Configure the name of the "pre-cache chain" and the "post-cache
           chain". The argument is the name of a chain that should be executed
           before and/or after the values have been added to the cache.

           To understand the implications, it's important you know what is
           going on inside collectd. The following diagram shows how values
           are passed from the read-plugins to the write-plugins:






4.10.2                      2010-11-27                         78





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


              +---------------+
              !  Read-Plugin  !
              +-------+-------+
                      !
            + - - - - V - - - - +
            : +---------------+ :
            : !   Pre-Cache   ! :
            : !     Chain     ! :
            : +-------+-------+ :
            :         !         :
            :         V         :
            : +-------+-------+ :  +---------------+
            : !     Cache     !--->!  Value Cache  !
            : !     insert    ! :  +---+---+-------+
            : +-------+-------+ :      !   !
            :         !   ,------------'   !
            :         V   V     :          V
            : +-------+---+---+ :  +-------+-------+
            : !  Post-Cache   +--->! Write-Plugins !
            : !     Chain     ! :  +---------------+
            : +---------------+ :
            :                   :
            :  dispatch values  :
            + - - - - - - - - - +

           After the values are passed from the "read" plugins to the dispatch
           functions, the pre-cache chain is run first. The values are added
           to the internal cache afterwards. The post-cache chain is run after
           the values have been added to the cache. So why is it such a huge
           deal if chains are run before or after the values have been added
           to this cache?

           Targets that change the identifier of a value list should be
           executed before the values are added to the cache, so that the name
           in the cache matches the name that is used in the "write" plugins.
           The "unixsock" plugin, too, uses this cache to receive a list of
           all available values. If you change the identifier after the value
           list has been added to the cache, this may easily lead to
           confusion, but it's not forbidden of course.

           The cache is also used to convert counter values to rates. These
           rates are, for example, used by the "value" match (see below). If
           you use the rate stored in the cache before the new value is added,
           you will use the old, previous rate. Write plugins may use this
           rate, too, see the "csv" plugin, for example.  The "unixsock"
           plugin uses these rates too, to implement the "GETVAL" command.

           Last but not last, the stop target makes a difference: If the pre-
           cache chain returns the stop condition, the value will not be added
           to the cache and the post-cache chain will not be run.

       Chain Name
           Adds a new chain with a certain name. This name can be used to
           refer to a specific chain, for example to jump to it.



4.10.2                      2010-11-27                         79





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


           Within the Chain block, there can be Rule blocks and Target blocks.

       Rule [Name]
           Adds a new rule to the current chain. The name of the rule is
           optional and currently has no meaning for the daemon.

           Within the Rule block, there may be any number of Match blocks and
           there must be at least one Target block.

       Match Name
           Adds a match to a Rule block. The name specifies what kind of match
           should be performed. Available matches depend on the plugins that
           have been loaded.

           The arguments inside the Match block are passed to the plugin
           implementing the match, so which arguments are valid here depends
           on the plugin being used.  If you do not need any to pass any
           arguments to a match, you can use the shorter syntax:

            Match "foobar"

           Which is equivalent to:

            <Match "foobar">
            </Match>

       Target Name
           Add a target to a rule or a default target to a chain. The name
           specifies what kind of target is to be added. Which targets are
           available depends on the plugins being loaded.

           The arguments inside the Target block are passed to the plugin
           implementing the target, so which arguments are valid here depends
           on the plugin being used.  If you do not need any to pass any
           arguments to a target, you can use the shorter syntax:

            Target "stop"

           This is the same as writing:

            <Target "stop">
            </Target>

   Built-in targets
       The following targets are built into the core daemon and therefore need
       no plugins to be loaded:

       return
           Signals the "return" condition, see the "Flow control" section
           above. This causes the current chain to stop processing the value
           and returns control to the calling chain. The calling chain will
           continue processing targets and rules just after the jump target
           (see below). This is very similar to the RETURN target of iptables,
           see iptables(8).



4.10.2                      2010-11-27                         80





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


           This target does not have any options.

           Example:

            Target "return"

       stop
           Signals the "stop" condition, see the "Flow control" section above.
           This causes processing of the value to be aborted immediately. This
           is similar to the DROP target of iptables, see iptables(8).

           This target does not have any options.

           Example:

            Target "stop"

       write
           Sends the value to "write" plugins.

           Available options:

           Plugin Name
               Name of the write plugin to which the data should be sent. This
               option may be given multiple times to send the data to more
               than one write plugin.

           If no plugin is explicitly specified, the values will be sent to
           all available write plugins.

           Example:

            <Target "write">
              Plugin "rrdtool"
            </Target>

       jump
           Starts processing the rules of another chain, see "Flow control"
           above. If the end of that chain is reached, or a stop condition is
           encountered, processing will continue right after the jump target,
           i. e. with the next target or the next rule. This is similar to the
           -j command line option of iptables, see iptables(8).

           Available options:

           Chain Name
               Jumps to the chain Name. This argument is required and may
               appear only once.

           Example:

            <Target "jump">
              Chain "foobar"
            </Target>



4.10.2                      2010-11-27                         81





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


   Available matches
       regex
           Matches a value using regular expressions.

           Available options:

           Host Regex
           Plugin Regex
           PluginInstance Regex
           Type Regex
           TypeInstance Regex
               Match values where the given regular expressions match the
               various fields of the identifier of a value. If multiple
               regular expressions are given, all regexen must match for a
               value to match.

           Invert false|true
               When set to true, the result of the match is inverted, i.e. all
               value lists where all regular expressions apply are not
               matched, all other value lists are matched. Defaults to false.

           Example:

            <Match "regex">
              Host "customer[0-9]+"
              Plugin "^foobar$"
            </Match>

       timediff
           Matches values that have a time which differs from the time on the
           server.

           This match is mainly intended for servers that receive values over
           the "network" plugin and write them to disk using the "rrdtool"
           plugin. RRDtool is very sensitive to the timestamp used when
           updating the RRD files. In particular, the time must be ever
           increasing. If a misbehaving client sends one packet with a
           timestamp far in the future, all further packets with a correct
           time will be ignored because of that one packet. What's worse, such
           corrupted RRD files are hard to fix.

           This match lets one match all values outside a specified time range
           (relative to the server's time), so you can use the stop target
           (see below) to ignore the value, for example.

           Available options:

           Future Seconds
               Matches all values that are ahead of the server's time by
               Seconds or more seconds. Set to zero for no limit. Either
               Future or Past must be non-zero.

           Past Seconds
               Matches all values that are behind of the server's time by



4.10.2                      2010-11-27                         82





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


               Seconds or more seconds. Set to zero for no limit. Either
               Future or Past must be non-zero.

           Example:

            <Match "timediff">
              Future  300
              Past   3600
            </Match>

           This example matches all values that are five minutes or more ahead
           of the server or one hour (or more) lagging behind.

       value
           Matches the actual value of data sources against given minimum /
           maximum values. If a data-set consists of more than one data-
           source, all data-sources must match the specified ranges for a
           positive match.

           Available options:

           Min Value
               Sets the smallest value which still results in a match. If
               unset, behaves like negative infinity.

           Max Value
               Sets the largest value which still results in a match. If
               unset, behaves like positive infinity.

           Invert true|false
               Inverts the selection. If the Min and Max settings result in a
               match, no-match is returned and vice versa. Please note that
               the Invert setting only effects how Min and Max are applied to
               a specific value. Especially the DataSource and Satisfy
               settings (see below) are not inverted.

           DataSource DSName [DSName ...]
               Select one or more of the data sources. If no data source is
               configured, all data sources will be checked. If the type
               handled by the match does not have a data source of the
               specified name(s), this will always result in no match
               (independent of the Invert setting).

           Satisfy Any|All
               Specifies how checking with several data sources is performed.
               If set to Any, the match succeeds if one of the data sources is
               in the configured range. If set to All the match only succeeds
               if all data sources are within the configured range. Default is
               All.

               Usually All is used for positive matches, Any is used for
               negative matches. This means that with All you usually check
               that all values are in a "good" range, while with Any you check
               if any value is within a "bad" range (or outside the "good"



4.10.2                      2010-11-27                         83





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


               range).

           Either Min or Max, but not both, may be unset.

           Example:

            # Match all values smaller than or equal to 100. Matches only if all data
            # sources are below 100.
            <Match "value">
              Max 100
              Satisfy "All"
            </Match>

            # Match if the value of any data source is outside the range of 0 - 100.
            <Match "value">
              Min   0
              Max 100
              Invert true
              Satisfy "Any"
            </Match>

       empty_counter
           Matches all values with one or more data sources of type COUNTER
           and where all counter values are zero. These counters usually never
           increased since they started existing (and are therefore
           uninteresting), or got reset recently or overflowed and you had
           really, really bad luck.

           Please keep in mind that ignoring such counters can result in
           confusing behavior: Counters which hardly ever increase will be
           zero for long periods of time. If the counter is reset for some
           reason (machine or service restarted, usually), the graph will be
           empty (NAN) for a long time. People may not understand why.

       hashed
           Calculates a hash value of the host name and matches values
           according to that hash value. This makes it possible to divide all
           hosts into groups and match only values that are in a specific
           group. The intended use is in load balancing, where you want to
           handle only part of all data and leave the rest for other servers.

           The hashing function used tries to distribute the hosts evenly.
           First, it calculates a 32 bit hash value using the characters of
           the hostname:

             hash_value = 0;
             for (i = 0; host[i] != 0; i++)
               hash_value = (hash_value * 251) + host[i];

           The constant 251 is a prime number which is supposed to make this
           hash value more random. The code then checks the group for this
           host according to the Total and Match arguments:





4.10.2                      2010-11-27                         84





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


             if ((hash_value % Total) == Match)
               matches;
             else
               does not match;

           Please note that when you set Total to two (i. e. you have only two
           groups), then the least significant bit of the hash value will be
           the XOR of all least significant bits in the host name. One
           consequence is that when you have two hosts, "server0.example.com"
           and "server1.example.com", where the host name differs in one digit
           only and the digits differ by one, those hosts will never end up in
           the same group.

           Available options:

           Match Match Total
               Divide the data into Total groups and match all hosts in group
               Match as described above. The groups are numbered from zero,
               i. e. Match must be smaller than Total. Total must be at least
               one, although only values greater than one really do make any
               sense.

               You can repeat this option to match multiple groups, for
               example:

                 Match 3 7
                 Match 5 7

               The above config will divide the data into seven groups and
               match groups three and five. One use would be to keep every
               value on two hosts so that if one fails the missing data can
               later be reconstructed from the second host.

           Example:

            # Operate on the pre-cache chain, so that ignored values are not even in the
            # global cache.
            <Chain "PreCache">
              <Rule>
                <Match "hashed">
                  # Divide all received hosts in seven groups and accept all hosts in
                  # group three.
                  Match 3 7
                </Match>
                # If matched: Return and continue.
                Target "return"
              </Rule>
              # If not matched: Return and stop.
              Target "stop"
            </Chain>

   Available targets
       notification
           Creates and dispatches a notification.



4.10.2                      2010-11-27                         85





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


           Available options:

           Message String
               This required option sets the message of the notification. The
               following placeholders will be replaced by an appropriate
               value:

               %{host}
               %{plugin}
               %{plugin_instance}
               %{type}
               %{type_instance}
                   These placeholders are replaced by the identifier field of
                   the same name.

               %{ds:name}
                   These placeholders are replaced by a (hopefully) human
                   readable representation of the current rate of this data
                   source. If you changed the instance name (using the set or
                   replace targets, see below), it may not be possible to
                   convert counter values to rates.

               Please note that these placeholders are case sensitive!

           Severity "FATAL"|"WARNING"|"OKAY"
               Sets the severity of the message. If omitted, the severity
               "WARNING" is used.

           Example:

             <Target "notification">
               Message "Oops, the %{type_instance} temperature is currently %{ds:value}!"
               Severity "WARNING"
             </Target>

       replace
           Replaces parts of the identifier using regular expressions.

           Available options:

           Host Regex Replacement
           Plugin Regex Replacement
           PluginInstance Regex Replacement
           TypeInstance Regex Replacement
               Match the appropriate field with the given regular expression
               Regex. If the regular expression matches, that part that
               matches is replaced with Replacement. If multiple places of the
               input buffer match a given regular expression, only the first
               occurrence will be replaced.

               You can specify each option multiple times to use multiple
               regular expressions one after another.

           Example:



4.10.2                      2010-11-27                         86





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


            <Target "replace">
              # Replace "example.net" with "example.com"
              Host "\\<example.net\\>" "example.com"

              # Strip "www." from hostnames
              Host "\\<www\\." ""
            </Target>

       set Sets part of the identifier of a value to a given string.

           Available options:

           Host String
           Plugin String
           PluginInstance String
           TypeInstance String
               Set the appropriate field to the given string. The strings for
               plugin instance and type instance may be empty, the strings for
               host and plugin may not be empty. It's currently not possible
               to set the type of a value this way.

           Example:

            <Target "set">
              PluginInstance "coretemp"
              TypeInstance "core3"
            </Target>

   Backwards compatibility
       If you use collectd with an old configuration, i. e. one without a
       Chain block, it will behave as it used to. This is equivalent to the
       following configuration:

        <Chain "PostCache">
          Target "write"
        </Chain>

       If you specify a PostCacheChain, the write target will not be added
       anywhere and you will have to make sure that it is called where
       appropriate. We suggest to add the above snippet as default target to
       your "PostCache" chain.

   Examples
       Ignore all values, where the hostname does not contain a dot, i. e.
       can't be an FQDN.












4.10.2                      2010-11-27                         87





COLLECTD.CONF(5)             collectd            COLLECTD.CONF(5)


        <Chain "PreCache">
          <Rule "no_fqdn">
            <Match "regex">
              Host "^[^\.]*$"
            </Match>
            Target "stop"
          </Rule>
          Target "write"
        </Chain>

SEE ALSO
       collectd(1), collectd-exec(5), collectd-perl(5), collectd-unixsock(5),
       types.db(5), hddtemp(8), iptables(8), kstat(3KSTAT), mbmon(1), psql(1),
       regex(7), rrdtool(1), sensors(1)

AUTHOR
       Florian Forster <octo@verplant.org>








































4.10.2                      2010-11-27                         88


